/**
 * 
 */
package cmis.junit.examples;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PropertyException;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;

import junit.framework.TestCase;

import org.oasis_open.docs.ns.cmis.core._200908.CmisAccessControlEntryType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisAccessControlListType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisAccessControlPrincipalType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisAllowableActionsType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisChangeEventType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisChoiceString;
import org.oasis_open.docs.ns.cmis.core._200908.CmisObjectType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertiesType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisProperty;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyBoolean;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyBooleanDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyDateTime;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyDateTimeDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyId;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyIdDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyInteger;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyIntegerDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyString;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyStringDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyUri;
import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertyUriDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisQueryType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisRepositoryCapabilitiesType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisRepositoryInfoType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisTypeDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisTypeDocumentDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisTypeFolderDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisTypePolicyDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisTypeRelationshipDefinitionType;
import org.oasis_open.docs.ns.cmis.core._200908.EnumBaseObjectTypeIds;
import org.oasis_open.docs.ns.cmis.core._200908.EnumBasicPermissions;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCapabilityACL;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCapabilityChanges;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCapabilityContentStreamUpdates;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCapabilityJoin;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCapabilityQuery;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCapabilityRendition;
import org.oasis_open.docs.ns.cmis.core._200908.EnumCardinality;
import org.oasis_open.docs.ns.cmis.core._200908.EnumContentStreamAllowed;
import org.oasis_open.docs.ns.cmis.core._200908.EnumDateTimeResolution;
import org.oasis_open.docs.ns.cmis.core._200908.EnumIncludeRelationships;
import org.oasis_open.docs.ns.cmis.core._200908.EnumPropertiesBase;
import org.oasis_open.docs.ns.cmis.core._200908.EnumPropertiesDocument;
import org.oasis_open.docs.ns.cmis.core._200908.EnumPropertiesFolder;
import org.oasis_open.docs.ns.cmis.core._200908.EnumPropertiesPolicy;
import org.oasis_open.docs.ns.cmis.core._200908.EnumPropertiesRelationship;
import org.oasis_open.docs.ns.cmis.core._200908.EnumPropertyType;
import org.oasis_open.docs.ns.cmis.core._200908.EnumRenditionKind;
import org.oasis_open.docs.ns.cmis.core._200908.EnumTypeOfChanges;
import org.oasis_open.docs.ns.cmis.core._200908.EnumUpdatability;
import org.oasis_open.docs.ns.cmis.restatom._200908.CmisUriTemplateType;
import org.oasis_open.docs.ns.cmis.restatom._200908.EnumCollectionType;
import org.oasis_open.docs.ns.cmis.restatom._200908.EnumLinkRelations;
import org.oasis_open.docs.ns.cmis.restatom._200908.EnumUriTemplateType;
import org.w3._2005.atom.AtomDateConstruct;
import org.w3._2005.atom.AtomPersonConstruct;
import org.w3._2005.atom.AtomTextConstruct;
import org.w3._2005.atom.Content;
import org.w3._2005.atom.EntryType;
import org.w3._2005.atom.FeedType;
import org.w3._2005.atom.Id;
import org.w3._2005.atom.Link;
import org.w3._2007.app.AppCollectionType;
import org.w3._2007.app.AppServiceType;
import org.w3._2007.app.AppWorkspaceType;

/**
 * @author abrown
 * 
 */
public class ExampleTest extends TestCase {
	// TODO validate cmis:path is present

	private static enum cmisFeedTypes {
		FOLDERCHILDREN, FOLDERDESCENDANTS, FOLDERTREE, QUERY, QUERYRESULT, CHECKEDOUT, UNFILED, TYPECHILDREN, TYPEDESCENDANTS, POLICIES, ALLVERSIONS, CHANGELOG, OBJECTPARENTS
	}

	private static enum httpMethod {
		GET, POST, PUT, DELETE;
	}

	private static enum httpStatus {
		S201("201 Created"), S200("200 Ok");

		private final String code;

		httpStatus(String code) {
			this.code = code;
		}

		public String code() {
			return code;
		}
	}

	private static final String _CORE = "org.oasis_open.docs.ns.cmis.core._200908";
	private static final String _MSG = "org.oasis_open.docs.ns.cmis.messaging._200908";
	private static final String _RA = "org.oasis_open.docs.ns.cmis.restatom._200908";
	private static final String _ATOM = "org.w3._2005.atom";

	private static final String _APP = "org.w3._2007.app";

	private static BigDecimal _CMIS_VERSION = BigDecimal.valueOf(0.62);
	private static final String AUTHOR_NAME = "Al Brown";
	private static final String AUTHOR_EMAIL = "albertcbrown@us.ibm.com";

	private static final String AUTHOR_URI = "http://www.ibm.com/";
	private static final String CS_LENGTH = "4123";

	private static final String CS_MIMETYPE = "text/plain";

	private static final String URL_BASE = "http://cmisexample.oasis-open.org/rep1/";

	private static boolean testFailed = false;

	public static final String MIMETYPE_QUERY = "application/cmisquery+xml";

	public static final String MIMETYPE_ATOM = "application/atom+xml";

	public static final String MIMETYPE_ATOMENTRY = "application/atom+xml;type=entry";
	public static final String MIMETYPE_ALLOWABLEACTIONS = "application/cmis+xml;type=allowableActions";
	public static final String MIMETYPE_ATOMFEED = "application/atom+xml;type=feed";
	public static final String MIMETYPE_TYPE = "application/cmis+xml;type=type";
	public static final String MIMETYPE_APPSERVICE = "application/atomsvc+xml";
	public static final String MIMETYPE_TEXT = "text/plain";
	public static final String MIMETYPE_HTML = "text/html";
	public static final String MIMETYPE_CMISTREE = "application/cmistree+xml";
	public static final String MIMETYPE_CMISATOM = "application/cmisatom+xml";
	public static final String MIMETYPE_CMISACL = "application/cmisacl+xml";
	public static final String MIMETYPE_CMISQUERY = "application/cmisquery+xml";
	private static String _PRODUCT_NAME = "CMIS Prototype for VendorX";
	private static String _PRODUCT_VERSION = _CMIS_VERSION.toString();

	private final static QName _href_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200908/", "href");
	private final static QName _id_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200908/", "id");
	private final static QName _renditionKind_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200908/",
			"renditionKind");

	private static String convertElementToString(JAXBElement request) {
		String buf = null;
		StringWriter writer = null;

		if (marshaller == null) {
			getMarshaller();
		}

		try {
			if (request != null) {
				writer = new StringWriter();
				marshaller.marshal(request, writer);
				buf = writer.toString();
			}
		} catch (JAXBException e) {
			e.printStackTrace();
			assertTrue(false);
		}

		return buf;
	}

	private static AtomDateConstruct getAtomDateConstruct(Date d) {
		AtomDateConstruct adc = new AtomDateConstruct();

		if (d == null) {
			return adc;
		}

		GregorianCalendar c = new GregorianCalendar();
		c.setTime(d);

		try {
			adc.setValue(DatatypeFactory.newInstance().newXMLGregorianCalendar(
					c));
		} catch (DatatypeConfigurationException e) {
			e.printStackTrace();
		}

		return adc;
	}

	/**
	 * @author abrown
	 * 
	 * @param string
	 * @param string2
	 * @param object
	 * @param object2
	 * @return
	 */
	private static Link getAtomLink(String rel, String href, String type,
			String length, String id, String title) {
		Link l = new Link();
		l.setHref(href);
		l.setRel(rel);
		l.setType(type);
		l.setLength(length);
		l.setTitle(title);

		// add in CMIS specific info (if applicable)
		if (id != null)
			l.getOtherAttributes().put(_id_QNAME, id);
		return l;
	}

	/**
	 * @author abrown
	 * 
	 * @param string
	 * @param string2
	 * @param string3
	 * @return
	 */
	private static AtomPersonConstruct getAtomPerson(String name, String email,
			String uri) {

		AtomPersonConstruct apc = new AtomPersonConstruct();
		apc.setName(name);
		apc.setEmail(email);
		apc.setUri(uri);

		return (apc);
	}

	/**
	 * @author abrown
	 * 
	 * @param text
	 * @param type
	 * @return
	 */
	private static AtomTextConstruct getAtomText(String text, String type) {
		AtomTextConstruct atc = new AtomTextConstruct();
		atc.getContent().add(text);
		atc.setType(type);

		return atc;
	}

	private static void getMarshaller() {
		try {
			jaxbContext = JAXBContext.newInstance(JAXB_PACKAGE_LIST);
			marshaller = jaxbContext.createMarshaller();

			try {
				marshaller.setProperty(Marshaller.JAXB_ENCODING, "UTF-8");
				marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT,
						Boolean.TRUE);

				marshaller.setProperty(
						"com.sun.xml.bind.namespacePrefixMapper",
						new NamespacePrefixMapperImpl());
				marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT,
						Boolean.TRUE);

			} catch (PropertyException e1) {
				// System.out.println("Property Exception : " + e1.toString());
				e1.printStackTrace();
			}

		} catch (JAXBException e) {
			e.printStackTrace();
		}

	}

	private static CmisProperty getPropertyBoolean(String pName, boolean b) {
		CmisPropertyBoolean p = new CmisPropertyBoolean();
		p.setLocalName("rep-" + pName);
		p.setPropertyDefinitionId(pName);
		p.getValue().add(b);

		return p;
	}

	private static CmisProperty getPropertyDate(String pName, Date date) {
		CmisPropertyDateTime p = new CmisPropertyDateTime();
		p.setLocalName("rep-" + pName);
		p.setPropertyDefinitionId(pName);

		GregorianCalendar c = new GregorianCalendar();
		c.setTime(date);

		try {
			p.getValue().add(
					DatatypeFactory.newInstance().newXMLGregorianCalendar(c));
		} catch (DatatypeConfigurationException e) {
			e.printStackTrace();
		}

		return p;
	}

	private static CmisProperty getPropertyId(String pName, String v) {
		return getPropertyId(pName, v, null);
	}

	private static CmisProperty getPropertyId(String pName, String v,
			String queryName) {
		CmisPropertyId p = new CmisPropertyId();
		p.setLocalName("rep-" + pName);
		p.setPropertyDefinitionId(pName);
		p.getValue().add(v);

		if (queryName != null)
			p.setQueryName(queryName);

		return p;
	}

	private static CmisProperty getPropertyInt(String pName, int v) {
		CmisPropertyInteger p = new CmisPropertyInteger();
		p.setLocalName("rep-" + pName);
		p.setPropertyDefinitionId(pName);
		p.getValue().add(BigInteger.valueOf(v));

		return p;
	}

	private static CmisPropertyString getPropertyString(String pName, String v) {
		return getPropertyString(pName, pName, v);
	}

	private static CmisPropertyString getPropertyString(String pName,
			String pdId, String v) {
		CmisPropertyString p = new CmisPropertyString();
		p.setLocalName("rep-" + pName);
		if (pdId != null)
			p.setPropertyDefinitionId(pName);
		p.getValue().add(v);

		return p;
	}

	private static CmisProperty getPropertyUri(String pName, String b) {
		CmisPropertyUri p = new CmisPropertyUri();
		p.setLocalName("rep-" + pName);
		p.setPropertyDefinitionId(pName);
		p.getValue().add(b);

		return p;
	}

	/**
	 * @author abrown
	 * 
	 * @param stmt
	 * @param pageSize
	 * @param skipCount
	 * @param retAllowable
	 * @param retAllVersions
	 * @return
	 */
	private static CmisQueryType getQueryType(String stmt, int pageSize,
			int skipCount, boolean retAllowable, boolean retAllVersions) {
		CmisQueryType cqt = new CmisQueryType();

		cqt.setStatement(stmt);
		cqt.setMaxItems(BigInteger.valueOf(pageSize));
		cqt.setSearchAllVersions(retAllVersions);
		cqt.setSkipCount(BigInteger.valueOf(skipCount));

		cqt.setIncludeAllowableActions(false);
		cqt.setIncludeRelationships(EnumIncludeRelationships.NONE);
		cqt.setRenditionFilter("*");

		return cqt;
	}

	public static boolean isTestFailed() {
		return testFailed;
	}

	public static void setTestFailed(boolean testFailed) {
		ExampleTest.testFailed = testFailed;
	}

	/**
	 * @param file
	 * @param uri
	 * @param headers
	 * @param bodyMediaType
	 * @param body
	 */
	private static void writeHTTPRequest(httpMethod hm, String file,
			String uri, Map<String, String> headers, String bodyMediaType,
			String body) {
		StringBuffer sb = new StringBuffer();

		/*
		 * POST /edit/ HTTP/1.1 Host: example.org User-Agent: Thingio/1.0
		 * Authorization: Basic ZGFmZnk6c2VjZXJldA== Content-Type:
		 * application/atom+xml;type=entry Content-Length: nnn Slug: First Post
		 * 
		 * <?xml version="1.0"?> <entry xmlns="http://www.w3.org/2005/Atom">
		 * <title>Atom-Powered Robots Run Amok</title>
		 * <id>urn:uuid:1225c695-cfb8-4ebb-aaaa-80da344efa6a</id>
		 * <updated>2003-12-13T18:30:02Z</updated> <author><name>John
		 * Doe</name></author> <content>Some text.</content> </entry>
		 */

		sb.append(hm.toString() + " " + uri + " HTTP/1.1");
		sb.append("\n");
		sb.append("Host: example.org\n");

		if (body != null) {
			sb.append("Content-Length: " + body.length());
			sb.append("\n");
		}

		if (bodyMediaType != null) {
			if (body != null) {
				sb.append("Content-Type: " + bodyMediaType);
				sb.append("\n");
			}
		}

		if (headers != null) {
			Iterator<String> it = headers.keySet().iterator();
			while (it.hasNext()) {
				String key = it.next();
				sb.append(key + ": " + headers.get(key) + "\n");
			}
		}

		if (body != null)
			sb.append("\n\n" + body);

		sb.append("\n");

		String fname = "examples/" + file + ".txt";

		FileOutputStream fos = null;
		OutputStreamWriter out = null;

		try {
			fos = new FileOutputStream(fname, false);
			out = new OutputStreamWriter(fos, "UTF-8");
			out.write(sb.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return;
	}

	/**
	 * @param file
	 * @param headers
	 * @param status
	 * @param bodyMediaType
	 * @param body
	 */
	private static void writeHTTPResponse(String file,
			Map<String, String> headers, httpStatus status,
			String bodyMediaType, String body) {
		StringBuffer sb = new StringBuffer();

		/*
		 * HTTP/1.1 201 Created Date: Fri, 7 Oct 2005 17:17:11 GMT
		 * Content-Length: nnn Content-Type:
		 * application/atom+xml;type=entry;charset="utf-8" Location:
		 * http://example.org/edit/first-post.atom ETag: "c180de84f991g8"
		 */

		Date d = new Date();
		SimpleDateFormat df = new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss Z");

		sb.append("HTTP/1.1 " + status.code());
		sb.append("\n");
		sb.append("Date: " + df.format(d) + "\n");

		if (body != null) {
			sb.append("Content-Length: " + body.length());
			sb.append("\n");
		}

		if (bodyMediaType != null) {
			sb.append("Content-Type: " + bodyMediaType);
			sb.append("\n");
		}

		if (headers != null) {
			Iterator<String> it = headers.keySet().iterator();
			while (it.hasNext()) {
				String key = it.next();
				sb.append(key + ": " + headers.get(key) + "\n");
			}
		}

		if (body != null) {
			sb.append("\n\n" + body);
			sb.append("\n");
		}

		String fname = "examples/" + file + ".txt";

		FileOutputStream fos = null;
		OutputStreamWriter out = null;

		try {
			fos = new FileOutputStream(fname, false);
			out = new OutputStreamWriter(fos, "UTF-8");
			out.write(sb.toString());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return;
	}

	private final org.oasis_open.docs.ns.cmis.core._200908.ObjectFactory coreFactory = new org.oasis_open.docs.ns.cmis.core._200908.ObjectFactory();

	private final org.oasis_open.docs.ns.cmis.restatom._200908.ObjectFactory raFactory = new org.oasis_open.docs.ns.cmis.restatom._200908.ObjectFactory();

	private final org.w3._2005.atom.ObjectFactory atomFactory = new org.w3._2005.atom.ObjectFactory();

	private final org.w3._2007.app.ObjectFactory appFactory = new org.w3._2007.app.ObjectFactory();

	private static final String JAXB_PACKAGE_LIST = _CORE + ":" + _MSG + ":"
			+ _ATOM + ":" + _APP + ":" + _RA;

	private static Marshaller marshaller;

	private static JAXBContext jaxbContext;

	private CmisAccessControlListType getACL() {
		CmisAccessControlListType acl = new CmisAccessControlListType();
		CmisAccessControlEntryType ace;
		CmisAccessControlPrincipalType acp;

		ace = new CmisAccessControlEntryType();
		acp = new CmisAccessControlPrincipalType();
		acp.setPrincipalId(AUTHOR_NAME);

		ace.setDirect(true);
		ace.setPrincipal(acp);
		ace.getPermission().add(EnumBasicPermissions.CMIS_READ.value());
		ace.getPermission().add(EnumBasicPermissions.CMIS_WRITE.value());
		ace.getPermission().add(EnumBasicPermissions.CMIS_ALL.value());
		ace.getPermission().add("publish");

		acl.getPermission().add(ace);
		return acl;
	}

	public CmisPropertyBooleanDefinitionType getBooleanPropertyDefinition(
			String name, EnumUpdatability eu) {
		CmisPropertyBooleanDefinitionType p = new CmisPropertyBooleanDefinitionType();

		p.setId(name);
		p.setLocalName("rep-" + name);

		p.setDescription("Description for " + name);
		p.setDisplayName(name);
		p.setCardinality(EnumCardinality.SINGLE);
		p.setInherited(true);
		p.setOpenChoice(false);
		p.setOrderable(true);
		p.setPropertyType(EnumPropertyType.BOOLEAN);
		p.setQueryable(true);
		p.setRequired(false);
		p.setUpdatability(eu);

		return p;
	}

	private AppCollectionType getCollectionType(EnumCollectionType cType,
			String title, String href) {
		AppCollectionType act = new AppCollectionType();

		act.getAny().add(raFactory.createCollectionType(cType.value()));

		// act.setCollectionType(cType);
		act.setHref(href);
		act.setTitle(getAtomText(title, "text"));

		switch (cType) {
		case CHECKEDOUT:
			act.getAccept().add(MIMETYPE_ATOMENTRY);
			break;
		case QUERY:
			act.getAccept().add(MIMETYPE_QUERY);
			break;
		case ROOT:
			break;
		case TYPES:
			break;
		case UNFILED:
			act.getAccept().add(MIMETYPE_ATOMENTRY);
		}

		return act;
	}

	public CmisPropertyDateTimeDefinitionType getDatePropertyDefinition(
			String name, EnumUpdatability eu) {
		CmisPropertyDateTimeDefinitionType p = new CmisPropertyDateTimeDefinitionType();

		p.setId(name);
		p.setLocalName("rep-" + name);

		p.setDescription("Description for " + name);
		p.setDisplayName(name);
		p.setCardinality(EnumCardinality.SINGLE);
		p.setInherited(true);
		p.setOpenChoice(false);
		p.setOrderable(true);
		p.setPropertyType(EnumPropertyType.DATETIME);
		p.setQueryable(true);
		p.setRequired(false);
		p.setUpdatability(eu);

		p.setResolution(EnumDateTimeResolution.TIME);

		return p;
	}

	public CmisPropertyIdDefinitionType getIdPropertyDefinition(String name,
			EnumUpdatability eu) {
		return getIdPropertyDefinition(name, eu, EnumCardinality.SINGLE);
	}

	public CmisPropertyIdDefinitionType getIdPropertyDefinition(String name,
			EnumUpdatability eu, EnumCardinality ec) {
		CmisPropertyIdDefinitionType p = new CmisPropertyIdDefinitionType();

		p.setId(name);
		p.setLocalName("rep-" + name);

		p.setDescription("Description for " + name);
		p.setDisplayName(name);
		p.setCardinality(ec);
		p.setInherited(true);
		p.setOpenChoice(false);
		p.setOrderable(true);
		p.setPropertyType(EnumPropertyType.ID);
		p.setQueryable(true);
		p.setRequired(false);
		p.setUpdatability(eu);

		return p;
	}

	public CmisPropertyIntegerDefinitionType getIntegerPropertyDefinition(
			String name, EnumUpdatability eu) {
		CmisPropertyIntegerDefinitionType p = new CmisPropertyIntegerDefinitionType();

		p.setId(name);
		p.setLocalName("rep-" + name);

		p.setDescription("Description for " + name);
		p.setDisplayName(name);
		p.setCardinality(EnumCardinality.SINGLE);
		p.setInherited(true);
		p.setOpenChoice(false);
		p.setOrderable(true);
		p.setPropertyType(EnumPropertyType.INTEGER);
		p.setQueryable(true);
		p.setRequired(false);
		p.setUpdatability(eu);

		p.setMaxValue(BigInteger.valueOf(Long.MAX_VALUE));
		p.setMinValue(BigInteger.valueOf(Long.MIN_VALUE));

		return p;
	}

	public CmisPropertyStringDefinitionType getStringPropertyDefinition(
			String name, EnumUpdatability eu, boolean includeChoice,
			boolean includeDefault) {
		CmisPropertyStringDefinitionType p = new CmisPropertyStringDefinitionType();

		p.setId(name);
		p.setLocalName("rep-" + name);

		p.setDescription("Description for " + name);
		p.setDisplayName(name);
		p.setCardinality(EnumCardinality.SINGLE);
		p.setInherited(true);
		p.setMaxLength(BigInteger.valueOf(128));

		p.setOpenChoice(false);
		p.setOrderable(true);
		p.setPropertyType(EnumPropertyType.STRING);
		p.setQueryable(true);
		p.setRequired(false);
		p.setUpdatability(eu);

		// set choices
		if (includeChoice) {
			CmisChoiceString c = new CmisChoiceString();
			c.setDisplayName("Choice 1");
			c.getValue().add("choice1value");
			p.getChoice().add(c);
			c = new CmisChoiceString();
			c.setDisplayName("Choice 2");
			c.getValue().add("choice2value");
			p.getChoice().add(c);
			c = new CmisChoiceString();
			c.setDisplayName("Choice 3");
			c.getValue().add("choice3value");
			p.getChoice().add(c);
		}

		if (includeDefault) {
			p.setDefaultValue(getPropertyString(name, null, "defaultvalue for "
					+ name));
		}

		return p;
	}

	public CmisPropertyUriDefinitionType getUriPropertyDefinition(String name,
			EnumUpdatability eu) {
		CmisPropertyUriDefinitionType p = new CmisPropertyUriDefinitionType();

		p.setId(name);
		p.setLocalName("rep-" + name);

		p.setDescription("Description for " + name);
		p.setDisplayName(name);
		p.setCardinality(EnumCardinality.SINGLE);
		p.setInherited(true);
		p.setOpenChoice(false);
		p.setOrderable(true);
		p.setPropertyType(EnumPropertyType.URI);
		p.setQueryable(true);
		p.setRequired(false);
		p.setUpdatability(eu);

		return p;
	}

	public CmisAllowableActionsType newAllowableActionsType(
			EnumBaseObjectTypeIds ot) {
		CmisAllowableActionsType aa = new CmisAllowableActionsType();

		aa.setCanDeleteObject(true);
		aa.setCanAddObjectToFolder(true);
		aa.setCanApplyPolicy(true);
		aa.setCanGetAppliedPolicies(true);
		aa.setCanGetProperties(true);
		aa.setCanGetObjectRelationships(true);
		aa.setCanMoveObject(true);
		aa.setCanRemoveObjectFromFolder(true);
		aa.setCanRemovePolicy(true);
		aa.setCanUpdateProperties(true);

		switch (ot) {
		case CMIS_DOCUMENT:
			aa.setCanCancelCheckOut(true);
			aa.setCanCheckIn(true);
			aa.setCanCheckOut(true);
			aa.setCanCreateDocument(true);
			aa.setCanDeleteContentStream(true);
			aa.setCanSetContentStream(true);
			aa.setCanGetContentStream(true);
			aa.setCanGetObjectParents(true);
			aa.setCanGetAllVersions(true);
			break;
		case CMIS_FOLDER:
			aa.setCanCreateFolder(true);
			aa.setCanGetChildren(true);
			aa.setCanGetDescendants(true);
			aa.setCanDeleteTree(true);
			aa.setCanGetFolderParent(true);
			break;
		case CMIS_POLICY:
			aa.setCanCreatePolicy(true);
			break;
		case CMIS_RELATIONSHIP:
			aa.setCanCreateRelationship(true);
			break;
		}

		return aa;
	}

	/**
	 * @param objectId
	 * @param bot
	 * @param typeid
	 * @param checkedout
	 * @param allowableActions
	 * @param changeEntry
	 * @param name
	 * @param pathSegment
	 * @param pFilter
	 * @param minimum
	 * @return
	 */
	public EntryType newAtomEntryType(String objectId,
			EnumBaseObjectTypeIds bot, String typeid, boolean checkedout,
			boolean allowableActions, EnumTypeOfChanges changeEntry,
			String name, String pathSegment, String pFilter, boolean minimum) {
		EntryType e = new EntryType();

		CmisObjectType cot = new CmisObjectType();
		CmisPropertiesType cpt = new CmisPropertiesType();

		PropertyFilter f = new PropertyFilter(pFilter);

		// <atom:author xml:base="http://tempuri.org" xml:lang="">
		// <atom:name>Al Brown</atom:name>
		// </atom:author>

		if (minimum) {
			e.getItems().add(
					atomFactory.createAuthor(getAtomPerson(AUTHOR_NAME, null,
							null)));
		} else {
			e.getItems().add(
					atomFactory.createAuthor(getAtomPerson(AUTHOR_NAME,
							AUTHOR_EMAIL, AUTHOR_URI)));
		}

		// <!-- atom:content -->
		// <atom:content src="http://www.cmis.org/rep1/media/document-entry">
		// </atom:content>

		Content c = new Content();
		c.setSrc(URL_BASE + objectId);
		e.getItems().add(c);

		// <!-- IRI to document entry resource -->
		// <atom:id>http://www.cmis.org/rep1/document-entry</atom:id>
		Id id = new Id();
		id.setContent("urn:uuid:" + objectId);
		e.getItems().add(id);

		// <atom:title>Document Entry example</atom:title>
		e.getItems().add(atomFactory.createTitle(getAtomText(name, "text")));

		// <!-- lastModifiedDate -->
		// <atom:updated>2001-12-31T12:00:00</atom:updated>
		e.getItems().add(
				atomFactory.createUpdated(getAtomDateConstruct(new Date())));

		// Ids

		f.addProperty(cpt, getPropertyId(EnumPropertiesBase.CMIS_OBJECT_ID
				.value(), objectId));
		f.addProperty(cpt, getPropertyId(EnumPropertiesBase.CMIS_OBJECT_TYPE_ID
				.value(), typeid));
		f.addProperty(cpt, getPropertyString(EnumPropertiesBase.CMIS_NAME
				.value(), name));

		if (!minimum) {
			// <!-- atom links -->
			// <atom:link rel='self'
			// href="http://www.cmis.org/rep1/document-entry"
			// />
			e.getItems().add(
					getAtomLink(EnumLinkRelations.SELF.value(), URL_BASE
							+ objectId, null, null, null, null));

			// <atom:link rel="edit"
			// href="http://www.cmis.org/rep1/document-entry"
			// />
			e.getItems().add(
					getAtomLink(EnumLinkRelations.EDIT.value(), URL_BASE
							+ objectId, null, null, null, null));

			// <atom:link rel="cmis-allowableactions"
			// href="http://www.cmis.org/rep1/document-entry/actions" />
			e.getItems().add(
					getAtomLink(
							EnumLinkRelations.CMIS_ALLOWABLEACTIONS.value(),
							URL_BASE + objectId + "/allowableactions",
							MIMETYPE_ALLOWABLEACTIONS, null, null, null));

			e.getItems().add(
					getAtomLink(EnumLinkRelations.DESCRIBEDBY.value(), URL_BASE
							+ objectId + "/type", MIMETYPE_ATOMENTRY, null,
							null, null));

			e.getItems()
					.add(
							getAtomLink(EnumLinkRelations.SERVICE.value(),
									URL_BASE + "/service", MIMETYPE_APPSERVICE,
									null, null, null));

			// <!-- createdDate -->
			// <atom:published>2001-12-31T12:00:00</atom:published>
			e.getItems().add(
					atomFactory
							.createPublished(getAtomDateConstruct(new Date())));

			// <atom:summary>
			// <!-- auto-generated HTML table of properties -->
			// </atom:summary>
			e.getItems().add(
					atomFactory.createSummary(getAtomText(
							"HTML summary of Entry  " + objectId, "html")));

			// Dates
			f.addProperty(cpt, getPropertyDate(
					EnumPropertiesBase.CMIS_CREATION_DATE.value(), new Date()));
			f.addProperty(cpt, getPropertyDate(
					EnumPropertiesBase.CMIS_LAST_MODIFICATION_DATE.value(),
					new Date()));

			f.addProperty(cpt, getPropertyId(
					EnumPropertiesBase.CMIS_BASE_TYPE_ID.value(), bot.value()));

			// Integers

			// Strings
			f.addProperty(cpt, getPropertyString(
					EnumPropertiesBase.CMIS_LAST_MODIFIED_BY.value(),
					AUTHOR_NAME));
			f.addProperty(cpt, getPropertyString(
					EnumPropertiesBase.CMIS_CREATED_BY.value(), AUTHOR_NAME));

		}

		// Uri

		cot.setProperties(cpt);

		if (allowableActions)
			cot.setAllowableActions(newAllowableActionsType(bot));

		e.getAnyOther().add(raFactory.createObject(cot));

		if (!minimum) {
			switch (bot) {
			case CMIS_DOCUMENT:
				f.addProperty(cpt, getPropertyBoolean(
						EnumPropertiesDocument.CMIS_IS_LATEST_VERSION.value(),
						true));
				f
						.addProperty(
								cpt,
								getPropertyBoolean(
										EnumPropertiesDocument.CMIS_IS_VERSION_SERIES_CHECKED_OUT
												.value(), checkedout));
				f.addProperty(cpt, getPropertyBoolean(
						EnumPropertiesDocument.CMIS_IS_MAJOR_VERSION.value(),
						false));
				f.addProperty(cpt, getPropertyBoolean(
						EnumPropertiesDocument.CMIS_IS_LATEST_MAJOR_VERSION
								.value(), false));

				// Bools
				f.addProperty(cpt,
						getPropertyBoolean(
								EnumPropertiesDocument.CMIS_IS_IMMUTABLE
										.value(), false));

				f.addProperty(cpt, getPropertyString(
						EnumPropertiesDocument.CMIS_CHECKIN_COMMENT.value(),
						"Checkin comment"));
				f.addProperty(cpt, getPropertyString(
						EnumPropertiesDocument.CMIS_VERSION_LABEL.value(),
						"0.1"));
				f.addProperty(cpt, getPropertyString(
						EnumPropertiesDocument.CMIS_CONTENT_STREAM_MIME_TYPE
								.value(), "text/plain"));
				f.addProperty(cpt, getPropertyString(
						EnumPropertiesDocument.CMIS_CONTENT_STREAM_FILE_NAME
								.value(), "text.txt"));
				f.addProperty(cpt, getPropertyInt(
						EnumPropertiesDocument.CMIS_CONTENT_STREAM_LENGTH
								.value(), 4234));

				// provide an MVP for a doc - keywords
				CmisPropertyString cps = new CmisPropertyString();
				cps.setPropertyDefinitionId("keywords");
				cps.setLocalName("keywords");
				cps.setDisplayName("Keywords for Document");
				cps.getValue().add("document");
				cps.getValue().add("example");
				cps.getValue().add("sample");
				cps.getValue().add("cmis");
				f.addProperty(cpt, cps);

				// <atom:link rel="edit-media"
				// href="http://www.cmis.org/rep1/media/document-entry" />
				e.getItems().add(
						getAtomLink("edit-media", URL_BASE + objectId
								+ "/edit-media", null, null, null, null));

				// <atom:link rel="alternate"
				// href="http://www.cmis.org/rep1/media/document-entry" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.ALTERNATE.value(),
								URL_BASE + objectId + "/alternate", null, null,
								null, null));

				// <!-- CMIS Links -->
				// <atom:link rel="cmis-parents"
				// href="http://www.cmis.org/rep1/document-entry/parents" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ objectId + "/parents", MIMETYPE_ATOMFEED,
								null, null, null));

				// <atom:link rel="cmis-allversions"
				// href="http://www.cmis.org/rep1/document-entry/allversions" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.VERSION_HISTORY.value(),
								URL_BASE + objectId + "/allversions",
								MIMETYPE_ATOMFEED, null, null, null));

				// <atom:link rel="cmis-latestversion"
				// href="http://www.cmis.org/rep1/document-entry/latestversion"
				// />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.CURRENT_VERSION.value(),
								URL_BASE + objectId + "/latest",
								MIMETYPE_ATOMENTRY, null, null, null));

				// <atom:link rel="cmis-relationships"
				// href="http://www.cmis.org/rep1/document-entry/relationships"
				// />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_RELATIONSHIPS
								.value(), URL_BASE + objectId
								+ "/relationships", MIMETYPE_ATOMFEED, null,
								null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_POLICIES.value(),
								URL_BASE + objectId + "/policies",
								MIMETYPE_ATOMFEED, null, null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_ACL.value(),
								URL_BASE + objectId + "/acl", MIMETYPE_CMISACL,
								null, null, null));

				if (checkedout) {
					f
							.addProperty(
									cpt,
									getPropertyId(
											EnumPropertiesDocument.CMIS_VERSION_SERIES_CHECKED_OUT_ID
													.value(), objectId));
					f
							.addProperty(
									cpt,
									getPropertyString(
											EnumPropertiesDocument.CMIS_VERSION_SERIES_CHECKED_OUT_BY
													.value(), AUTHOR_NAME));
					e.getItems().add(
							getAtomLink(EnumLinkRelations.WORKING_COPY.value(),
									URL_BASE + objectId + "/pwc",
									MIMETYPE_ATOMFEED, null, null, null));

				}

				break;
			case CMIS_FOLDER:
				// <atom:link rel="cmis-parent"
				// href="http://www.cmis.org/rep1/folder-entry/parent" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ objectId + "/up", MIMETYPE_ATOMENTRY, null,
								null, null));

				// <cmis:propertyId
				// cmis:name="parentId"><cmis:value>parentFolderId1<
				// /cmis:value></cmis:propertyId>
				f.addProperty(cpt, getPropertyId(
						EnumPropertiesFolder.CMIS_PARENT_ID.value(), objectId
								+ "up"));

				// down
				e.getItems().add(
						getAtomLink(EnumLinkRelations.DOWN.value(), URL_BASE
								+ objectId + "/children", MIMETYPE_ATOMFEED,
								null, null, null));

				// down tree
				e.getItems().add(
						getAtomLink(EnumLinkRelations.DOWN.value(), URL_BASE
								+ objectId + "/tree", MIMETYPE_CMISTREE, null,
								null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_FOLDERTREE.value(),
								URL_BASE + objectId + "/foldertree",
								MIMETYPE_ATOMFEED, null, null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_RELATIONSHIPS
								.value(), URL_BASE + objectId
								+ "/relationships", MIMETYPE_ATOMFEED, null,
								null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_POLICIES.value(),
								URL_BASE + objectId + "/policies",
								MIMETYPE_ATOMFEED, null, null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_ACL.value(),
								URL_BASE + objectId + "/acl", MIMETYPE_CMISACL,
								null, null, null));
				break;
			case CMIS_POLICY:
				// <!-- CMIS Links -->
				// <atom:link rel="cmis-parents"
				// href="http://www.cmis.org/rep1/document-entry/parents" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ objectId + "/parents", MIMETYPE_ATOMFEED,
								null, null, null));

				// <atom:link rel="cmis-relationships"
				// href="http://www.cmis.org/rep1/document-entry/relationships"
				// />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_RELATIONSHIPS
								.value(), URL_BASE + objectId
								+ "/relationships", MIMETYPE_ATOMFEED, null,
								null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_ACL.value(),
								URL_BASE + objectId + "/acl", MIMETYPE_CMISACL,
								null, null, null));
				break;
			case CMIS_RELATIONSHIP:
				// <atom:link rel="cmis-source"
				// href="http://www.cmis.org/rep1/policy-entry/source" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_SOURCE.value(),
								URL_BASE + objectId + "/source",
								MIMETYPE_ATOMENTRY, null, null, null));

				// <atom:link rel="cmis-target"
				// href="http://www.cmis.org/rep1/policy-entry/target" />
				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_TARGET.value(),
								URL_BASE + objectId + "/target",
								MIMETYPE_ATOMENTRY, null, null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_POLICIES.value(),
								URL_BASE + objectId + "/policies",
								MIMETYPE_ATOMFEED, null, null, null));

				e.getItems().add(
						getAtomLink(EnumLinkRelations.CMIS_ACL.value(),
								URL_BASE + objectId + "/acl", MIMETYPE_CMISACL,
								null, null, null));

				f.addProperty(cpt, getPropertyId(
						EnumPropertiesRelationship.CMIS_SOURCE_ID.value(), UUID
								.randomUUID().toString()));

				f.addProperty(cpt, getPropertyId(
						EnumPropertiesRelationship.CMIS_TARGET_ID.value(), UUID
								.randomUUID().toString()));
				break;
			}
		}

		// Unified search
		if (changeEntry != null) {
			CmisChangeEventType ccet = new CmisChangeEventType();

			ccet.setChangeType(EnumTypeOfChanges.UPDATED);
			GregorianCalendar cal = new GregorianCalendar();
			cal.setTime(new Date());
			XMLGregorianCalendar xgdt = null;
			try {
				xgdt = DatatypeFactory.newInstance().newXMLGregorianCalendar(
						cal);
			} catch (DatatypeConfigurationException ex) {
				ex.printStackTrace();
			}

			ccet.setChangeTime(xgdt);
			cot.setChangeEventInfo(ccet);
		}

		if (pathSegment != null)
			e.getAnyOther().add(raFactory.createPathSegment(pathSegment));

		return e;

	}

	/**
	 * @param ft
	 * @param id
	 * @param title
	 * @param paging
	 * @param parentId
	 * @return
	 */
	private FeedType newAtomFeedType(cmisFeedTypes ft, String id, String title,
			boolean paging, String parentId) {
		FeedType f = new FeedType();
		f.getItems().add(atomFactory.createTitle(getAtomText(title, "text")));
		f.getItems().add(
				atomFactory.createAuthor(getAtomPerson(AUTHOR_NAME,
						AUTHOR_EMAIL, AUTHOR_URI)));

		// Set update to now
		f.getItems().add(
				atomFactory.createUpdated(getAtomDateConstruct(new Date())));

		// set the id
		Id aId = new Id();
		aId.setContent("urn:uuid:" + UUID.randomUUID().toString());
		f.getItems().add(aId);

		// Links on everything
		// add self link
		f.getItems().add(
				getAtomLink(EnumLinkRelations.SELF.value(), URL_BASE + id
						+ "/3", MIMETYPE_ATOMFEED, null, null, null));

		f.getItems().add(
				getAtomLink(EnumLinkRelations.SERVICE.value(), URL_BASE
						+ "/service", MIMETYPE_APPSERVICE, null, null, null));

		AppCollectionType apc = new AppCollectionType();
		// setup app:collection
		apc.setHref(URL_BASE + id + "/3");
		apc.setTitle(getAtomText(title, "text"));

		// TODO Change UP to atom entry rather than feed
		switch (ft) {
		case CHECKEDOUT:
			apc.getAccept().add(MIMETYPE_CMISATOM);
			f.getAnyOther().add(appFactory.createCollection(apc));
			break;

		case UNFILED:
			apc.getAccept().add(MIMETYPE_CMISATOM);
			f.getAnyOther().add(appFactory.createCollection(apc));
			break;

		case CHANGELOG:
			break;

		case QUERY:
			apc.getAccept().add(MIMETYPE_CMISQUERY);
			f.getAnyOther().add(appFactory.createCollection(apc));
			break;

		case QUERYRESULT:
			break;

		case ALLVERSIONS:
			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));
			break;
		case OBJECTPARENTS:
			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));
			break;

		case FOLDERCHILDREN:
			apc.getAccept().add(MIMETYPE_ATOM);
			apc.getAccept().add(MIMETYPE_CMISATOM);
			apc.getAccept().add("*/*");
			f.getAnyOther().add(appFactory.createCollection(apc));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.CMIS_FOLDERTREE.value(),
							URL_BASE + id + "/foldertree", MIMETYPE_ATOMFEED,
							null, null, null));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.DOWN.value(), URL_BASE + id
							+ "/tree", MIMETYPE_CMISTREE, null, null, null));

			if (parentId != null)
				f.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ parentId, MIMETYPE_ATOMENTRY, null, null,
								null));
			break;
		case FOLDERDESCENDANTS:
			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.CMIS_FOLDERTREE.value(),
							URL_BASE + id + "/foldertree", MIMETYPE_ATOMFEED,
							null, null, null));

			f.getItems()
					.add(
							getAtomLink(EnumLinkRelations.DOWN.value(),
									URL_BASE + id + "/children",
									MIMETYPE_ATOMFEED, null, null, null));

			if (parentId != null)
				f.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ parentId, MIMETYPE_ATOMENTRY, null, null,
								null));
			break;

		case FOLDERTREE:
			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.DOWN.value(), URL_BASE + id
							+ "/tree", MIMETYPE_CMISTREE, null, null, null));

			f.getItems()
					.add(
							getAtomLink(EnumLinkRelations.DOWN.value(),
									URL_BASE + id + "/children",
									MIMETYPE_ATOMFEED, null, null, null));

			if (parentId != null)
				f.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ parentId, MIMETYPE_ATOMENTRY, null, null,
								null));
			break;

		case POLICIES:
			apc.getAccept().add(MIMETYPE_CMISATOM);
			f.getAnyOther().add(appFactory.createCollection(apc));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));
			break;

		case TYPECHILDREN:
			f.getAnyOther().add(appFactory.createCollection(apc));

			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));
			f.getItems().add(
					getAtomLink(EnumLinkRelations.DOWN.value(), URL_BASE + id
							+ "/tree", MIMETYPE_CMISTREE, null, null, null));

			if (parentId != null)
				f.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ parentId, MIMETYPE_ATOMENTRY, null, null,
								null));
			break;
		case TYPEDESCENDANTS:
			f.getItems().add(
					getAtomLink(EnumLinkRelations.VIA.value(), URL_BASE + id,
							MIMETYPE_ATOMENTRY, null, null, null));
			f.getItems()
					.add(
							getAtomLink(EnumLinkRelations.DOWN.value(),
									URL_BASE + id + "/children",
									MIMETYPE_ATOMFEED, null, null, null));

			if (parentId != null)
				f.getItems().add(
						getAtomLink(EnumLinkRelations.UP.value(), URL_BASE
								+ parentId, MIMETYPE_ATOMENTRY, null, null,
								null));
			break;

		}

		if (paging) {
			// <!-- RFC 5005 Feed Paging -->
			// <atom:link rel="first"
			// href="http://www.cmis.org/rep1/folder1/children" />
			f.getItems().add(
					getAtomLink(EnumLinkRelations.FIRST.value(), URL_BASE + id
							+ "/first", MIMETYPE_ATOMFEED, null, null, null));

			// <atom:link rel="next"
			// href="http://www.cmis.org/rep1/folder1/children/4" />
			f.getItems().add(
					getAtomLink(EnumLinkRelations.NEXT.value(), URL_BASE + id
							+ "/4", MIMETYPE_ATOMFEED, null, null, null));

			// <atom:link rel="previous"
			// href="http://www.cmis.org/rep1/folder1/children/2" />
			f.getItems().add(
					getAtomLink(EnumLinkRelations.PREVIOUS.value(), URL_BASE
							+ id + "/2", MIMETYPE_ATOMFEED, null, null, null));

			// <atom:link rel="last"
			// href="http://www.cmis.org/rep1/folder1/children/last" />
			f.getItems().add(
					getAtomLink(EnumLinkRelations.LAST.value(), URL_BASE + id
							+ "/last", MIMETYPE_ATOMFEED, null, null, null));
		}

		return f;
	}

	/**
	 * @author abrown
	 * 
	 * @return
	 */
	private AppServiceType newServiceType() {
		AppServiceType ast = new AppServiceType();
		AppWorkspaceType awt = new AppWorkspaceType();
		ast.getWorkspace().add(awt);

		awt.setTitle(getAtomText("CMIS Repository", "text"));

		awt.getCollection().add(
				getCollectionType(EnumCollectionType.CHECKEDOUT,
						"Checkedout collection", URL_BASE + "/checkedout"));
		awt.getCollection().add(
				getCollectionType(EnumCollectionType.QUERY, "Query collection",
						URL_BASE + "/query"));
		awt.getCollection().add(
				getCollectionType(EnumCollectionType.ROOT,
						"Root children collection", URL_BASE + "/rootc"));
		awt.getCollection().add(
				getCollectionType(EnumCollectionType.TYPES,
						"Types children collection", URL_BASE + "/typec"));
		awt.getCollection().add(
				getCollectionType(EnumCollectionType.UNFILED,
						"Unfiled collection", URL_BASE + "/unfiled"));
		awt.getCollection().add(
				getCollectionType(EnumCollectionType.CHANGES,
						"changes collection", URL_BASE + "/changes"));

		Link l = null;

		l = getAtomLink(EnumLinkRelations.CMIS_TYPEDESCENDANTS.value(),
				URL_BASE + "/typesdescendants", MIMETYPE_ATOMFEED, null, null,
				"Types Descendants feed");

		awt.getAny().add(l);
		l = getAtomLink(EnumLinkRelations.CMIS_FOLDERTREE.value(), URL_BASE
				+ "/foldertree", MIMETYPE_ATOMFEED, null, null,
				"Folder Tree feed for root folder");

		awt.getAny().add(l);

		CmisRepositoryInfoType crit = new CmisRepositoryInfoType();

		crit.setCmisVersionSupported(_CMIS_VERSION);
		crit.setProductName("ProductName");
		crit.setProductVersion("0.60");
		crit.setProductName(_PRODUCT_NAME);
		crit.setProductVersion(_PRODUCT_VERSION);
		crit.setRepositoryDescription("CMIS Repository Description");
		crit.setRepositoryId("repid1");
		crit.setRepositoryName("Repository1");
		crit.setRootFolderId("rootfolder");
		crit.setVendorName("CMIS Vendor 1");

		crit.setChangesIncomplete(Boolean.TRUE);

		crit.setLatestChangeLogToken("token-" + (new Date()).toString());

		// save it
		awt.getAny().add(raFactory.createRepositoryInfo(crit));

		CmisRepositoryCapabilitiesType crct = new CmisRepositoryCapabilitiesType();
		crct.setCapabilityAllVersionsSearchable(true);
		crct.setCapabilityJoin(EnumCapabilityJoin.INNERANDOUTER);
		crct.setCapabilityMultifiling(true);
		crct.setCapabilityPWCSearchable(true);
		crct.setCapabilityPWCUpdatable(true);
		crct.setCapabilityQuery(EnumCapabilityQuery.BOTHCOMBINED);
		crct.setCapabilityUnfiling(true);
		crct.setCapabilityVersionSpecificFiling(true);
		crct.setCapabilityGetDescendants(true);

		// ACL
		crct.setCapabilityACL(EnumCapabilityACL.MANAGE);

		// Content Stream Updates
		crct
				.setCapabilityContentStreamUpdatability(EnumCapabilityContentStreamUpdates.ANYTIME);

		// Unified Search Proposal
		crct.setCapabilityChanges(EnumCapabilityChanges.ALL);

		crit.getChangesOnType().add(EnumBaseObjectTypeIds.CMIS_DOCUMENT);
		crit.getChangesOnType().add(EnumBaseObjectTypeIds.CMIS_FOLDER);

		// renditions
		crct.setCapabilityRenditions(EnumCapabilityRendition.READ);

		// save
		crit.setCapabilities(crct);

		// add in uri templates
		CmisUriTemplateType cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMENTRY);
		cut.setType(EnumUriTemplateType.OBJECTBYID.value());
		cut
				.setTemplate(URL_BASE
						+ "objectbyid/{id}?filter={filter}&includeAllowableActions={includeAllowableActions}&includePolicyIds={includePolicyIds}&includeRelationships={includeRelationships}&includeACL={includeACL}");
		JAXBElement<CmisUriTemplateType> elUri = raFactory
				.createUritemplate(cut);
		awt.getAny().add(elUri);

		cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMENTRY);
		cut.setType(EnumUriTemplateType.OBJECTBYPATH.value());
		cut
				.setTemplate(URL_BASE
						+ "objectbypath?p={path}&filter={filter}&includeAllowableActions={includeAllowableActions}&includePolicyIds={includePolicyIds}&includeRelationships={includeRelationships}&includeACL={includeACL}");
		elUri = raFactory.createUritemplate(cut);
		awt.getAny().add(elUri);

		cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMENTRY);
		cut.setType(EnumUriTemplateType.QUERY.value());
		cut
				.setTemplate(URL_BASE
						+ "query?q={path}&searchAllVersions={searchAllVersions}&maxItems={maxItems}&skipCount={skipCount}&includeAllowableActions={includeAllowableActions}=&includeRelationships={includeRelationships}");
		elUri = raFactory.createUritemplate(cut);
		awt.getAny().add(elUri);

		return ast;
	}

	/**
	 * @param name
	 * @param bot
	 * @param incPDs
	 * @return
	 */
	private EntryType newTypeDefinitionType(String name,
			EnumBaseObjectTypeIds bot, boolean incPDs) {
		EntryType e = new EntryType();

		String selfUrl = URL_BASE + "type/" + name;
		// <atom:author xml:base="http://tempuri.org" xml:lang="">
		// <atom:name>Al Brown</atom:name>
		// </atom:author>
		e.getItems().add(
				atomFactory.createAuthor(getAtomPerson(AUTHOR_NAME,
						AUTHOR_EMAIL, AUTHOR_URI)));

		// <!-- atom:content -->
		// <atom:content src="http://www.cmis.org/rep1/media/document-entry">
		// </atom:content>

		Content c = new Content();
		c.getContent().add(new String("Type Definition for " + name));
		e.getItems().add(c);

		// <!-- IRI to document entry resource -->
		// <atom:id>http://www.cmis.org/rep1/document-entry</atom:id>
		Id id = new Id();
		id.setContent(selfUrl);
		e.getItems().add(id);

		// <!-- atom links -->
		// <atom:link rel='self' href="http://www.cmis.org/rep1/document-entry"
		// />
		e.getItems().add(
				getAtomLink(EnumLinkRelations.SELF.value(), selfUrl,
						MIMETYPE_ATOMENTRY, null, null, null));

		// service
		e.getItems().add(
				getAtomLink(EnumLinkRelations.SERVICE.value(), selfUrl,
						MIMETYPE_APPSERVICE, null, null, null));

		// service
		e.getItems().add(
				getAtomLink(EnumLinkRelations.DESCRIBEDBY.value(), URL_BASE
						+ "type/" + bot.value(), MIMETYPE_ATOMENTRY, null,
						null, null));

		// up
		e.getItems().add(
				getAtomLink(EnumLinkRelations.UP.value(), selfUrl + "/parent",
						MIMETYPE_ATOMENTRY, null, null, null));

		// down
		e.getItems()
				.add(
						getAtomLink(EnumLinkRelations.DOWN.value(), selfUrl
								+ "/children/flat", MIMETYPE_ATOMFEED, null,
								null, null));

		// down tree
		e.getItems()
				.add(
						getAtomLink(EnumLinkRelations.DOWN.value(), selfUrl
								+ "/children/tree", MIMETYPE_CMISTREE, null,
								null, null));

		// <!-- createdDate -->
		// <atom:published>2001-12-31T12:00:00</atom:published>
		e.getItems().add(
				atomFactory.createPublished(getAtomDateConstruct(new Date())));

		// <atom:summary>
		// <!-- auto-generated HTML table of properties -->
		// </atom:summary>
		e.getItems().add(
				atomFactory.createSummary(getAtomText(
						"HTML summary of Type Definition  " + name, "html")));

		// <atom:title>Document Entry example</atom:title>
		e.getItems().add(
				atomFactory.createTitle(getAtomText(
						"Type Definition - " + name, "text")));

		// <!-- lastModifiedDate -->
		// <atom:updated>2001-12-31T12:00:00</atom:updated>
		e.getItems().add(
				atomFactory.createUpdated(getAtomDateConstruct(new Date())));

		// add app:edited
		e.getAnyOther().add(
				appFactory.createEdited(getAtomDateConstruct(new Date())));

		CmisTypeDefinitionType ctdt = null;

		switch (bot) {
		case CMIS_DOCUMENT:
			CmisTypeDocumentDefinitionType dt = new CmisTypeDocumentDefinitionType();
			ctdt = dt;

			dt.setFileable(true);
			dt.setVersionable(true);
			dt.setContentStreamAllowed(EnumContentStreamAllowed.ALLOWED);

			break;
		case CMIS_FOLDER:
			CmisTypeFolderDefinitionType ft = new CmisTypeFolderDefinitionType();
			ctdt = ft;

			ft.setFileable(true);
			break;
		case CMIS_POLICY:
			CmisTypePolicyDefinitionType pt = new CmisTypePolicyDefinitionType();
			ctdt = pt;

			pt.setFileable(false);

			break;
		case CMIS_RELATIONSHIP:
			CmisTypeRelationshipDefinitionType rt = new CmisTypeRelationshipDefinitionType();
			ctdt = rt;

			rt.getAllowedSourceTypes().add("invoice");
			rt.getAllowedSourceTypes().add("capitalinvoice");
			rt.getAllowedTargetTypes().add("customer");

			rt.setFileable(false);

			break;
		}

		if (ctdt != null) {
			// set base type id
			ctdt.setBaseId(bot);

			ctdt.setId("dt" + name);
			ctdt.setLocalName("myrepname-" + name);
			ctdt.setQueryName(name);
			ctdt.setDisplayName(name);
			ctdt.setLocalNamespace(null);
			ctdt.setParentId("parent");
			ctdt.setDescription("Description for type definition " + name);

			// flags
			ctdt.setCreatable(true);

			ctdt.setControllableACL(true);
			ctdt.setControllablePolicy(true);
			ctdt.setIncludedInSupertypeQuery(true);

			if (incPDs) {
				// base properties on everything
				ctdt.getPropertyDefinition().add(
						getIdPropertyDefinition(
								EnumPropertiesBase.CMIS_BASE_TYPE_ID.value(),
								EnumUpdatability.READONLY));

				ctdt.getPropertyDefinition().add(
						getStringPropertyDefinition(
								EnumPropertiesBase.CMIS_NAME.value(),
								EnumUpdatability.READWRITE, false, false));
				ctdt.getPropertyDefinition().add(
						getIdPropertyDefinition(
								EnumPropertiesBase.CMIS_OBJECT_ID.value(),
								EnumUpdatability.READONLY));
				ctdt.getPropertyDefinition().add(
						getStringPropertyDefinition(
								EnumPropertiesBase.CMIS_OBJECT_TYPE_ID.value(),
								EnumUpdatability.READONLY, false, false));
				ctdt.getPropertyDefinition().add(
						getStringPropertyDefinition(
								EnumPropertiesBase.CMIS_BASE_TYPE_ID.value(),
								EnumUpdatability.READONLY, false, false));
				ctdt.getPropertyDefinition().add(
						getStringPropertyDefinition(
								EnumPropertiesBase.CMIS_CREATED_BY.value(),
								EnumUpdatability.READONLY, false, false));
				ctdt.getPropertyDefinition().add(
						getDatePropertyDefinition(
								EnumPropertiesBase.CMIS_CREATION_DATE.value(),
								EnumUpdatability.READONLY));
				ctdt.getPropertyDefinition().add(
						getStringPropertyDefinition(
								EnumPropertiesBase.CMIS_LAST_MODIFIED_BY
										.value(), EnumUpdatability.READONLY,
								false, false));
				ctdt.getPropertyDefinition().add(
						getDatePropertyDefinition(
								EnumPropertiesBase.CMIS_LAST_MODIFICATION_DATE
										.value(), EnumUpdatability.READONLY));
				ctdt.getPropertyDefinition().add(
						getStringPropertyDefinition(
								EnumPropertiesBase.CMIS_CHANGE_TOKEN.value(),
								EnumUpdatability.READONLY, false, false));

				switch (bot) {
				case CMIS_DOCUMENT:
					// properties
					ctdt
							.getPropertyDefinition()
							.add(
									getBooleanPropertyDefinition(
											EnumPropertiesDocument.CMIS_IS_IMMUTABLE
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getBooleanPropertyDefinition(
											EnumPropertiesDocument.CMIS_IS_LATEST_VERSION
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getBooleanPropertyDefinition(
											EnumPropertiesDocument.CMIS_IS_MAJOR_VERSION
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getBooleanPropertyDefinition(
											EnumPropertiesDocument.CMIS_IS_LATEST_MAJOR_VERSION
													.value(),
											EnumUpdatability.READONLY));
					ctdt.getPropertyDefinition().add(
							getStringPropertyDefinition(
									EnumPropertiesDocument.CMIS_VERSION_LABEL
											.value(),
									EnumUpdatability.READONLY, false, false));
					ctdt
							.getPropertyDefinition()
							.add(
									getIdPropertyDefinition(
											EnumPropertiesDocument.CMIS_VERSION_SERIES_ID
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getBooleanPropertyDefinition(
											EnumPropertiesDocument.CMIS_IS_VERSION_SERIES_CHECKED_OUT
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getStringPropertyDefinition(
											EnumPropertiesDocument.CMIS_VERSION_SERIES_CHECKED_OUT_BY
													.value(),
											EnumUpdatability.READONLY, false,
											false));
					ctdt
							.getPropertyDefinition()
							.add(
									getIdPropertyDefinition(
											EnumPropertiesDocument.CMIS_VERSION_SERIES_CHECKED_OUT_ID
													.value(),
											EnumUpdatability.READONLY));
					ctdt.getPropertyDefinition().add(
							getStringPropertyDefinition(
									EnumPropertiesDocument.CMIS_CHECKIN_COMMENT
											.value(),
									EnumUpdatability.READONLY, false, false));

					// cs stream
					ctdt
							.getPropertyDefinition()
							.add(
									getIntegerPropertyDefinition(
											EnumPropertiesDocument.CMIS_CONTENT_STREAM_LENGTH
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getStringPropertyDefinition(
											EnumPropertiesDocument.CMIS_CONTENT_STREAM_MIME_TYPE
													.value(),
											EnumUpdatability.READONLY, false,
											false));
					ctdt
							.getPropertyDefinition()
							.add(
									getStringPropertyDefinition(
											EnumPropertiesDocument.CMIS_CONTENT_STREAM_FILE_NAME
													.value(),
											EnumUpdatability.READONLY, false,
											false));

					// add in some custom properties
					ctdt.getPropertyDefinition().add(
							getStringPropertyDefinition("custom-customertype",
									EnumUpdatability.READWRITE, true, true));

					break;
				case CMIS_FOLDER:
					ctdt.getPropertyDefinition()
							.add(
									getIdPropertyDefinition(
											EnumPropertiesFolder.CMIS_PARENT_ID
													.value(),
											EnumUpdatability.READONLY));
					ctdt
							.getPropertyDefinition()
							.add(
									getIdPropertyDefinition(
											EnumPropertiesFolder.CMIS_ALLOWED_CHILD_OBJECT_TYPE_IDS
													.value(),
											EnumUpdatability.READWRITE,
											EnumCardinality.MULTI));

					break;
				case CMIS_POLICY:
					ctdt.getPropertyDefinition().add(
							getStringPropertyDefinition(
									EnumPropertiesPolicy.CMIS_POLICY_TEXT
											.value(),
									EnumUpdatability.READWRITE, false, false));
					break;
				case CMIS_RELATIONSHIP:
					ctdt.getPropertyDefinition().add(
							getIdPropertyDefinition(
									EnumPropertiesRelationship.CMIS_SOURCE_ID
											.value(),
									EnumUpdatability.READWRITE));
					ctdt.getPropertyDefinition().add(
							getIdPropertyDefinition(
									EnumPropertiesRelationship.CMIS_TARGET_ID
											.value(),
									EnumUpdatability.READWRITE));
					break;
				}
			}

			// add in optional id attribute

			ctdt
					.getOtherAttributes()
					.put(
							new QName(
									"http://docs.oasis-open.org/ns/cmis/restatom/200908/",
									"id"), name);

			e.getAnyOther().add(raFactory.createType(ctdt));
		}
		return e;

	}

	public void test01AllowableActions() {
		CmisAllowableActionsType aa = newAllowableActionsType(EnumBaseObjectTypeIds.CMIS_DOCUMENT);

		// write it
		JAXBElement<CmisAllowableActionsType> element = coreFactory
				.createAllowableActions(aa);
		writeOutput("AllowableActions", element);
	}

	public void test10DocumentEntry() {
		EntryType e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false, true,
				null, "CMIS Example Document", null, null, false);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("DocumentEntry", element);

		EntryTypeHelper eh = new EntryTypeHelper(e);
		System.out.println("Entry: " + eh.getTitle().getContent().get(0));
	}

	public void test11DocumentEntryPWC() {
		UUID u = UUID.randomUUID();

		EntryType e = newAtomEntryType(u.toString(),
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", true, true,
				null, "CMIS Example Document for PWC", null, null, false);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("DocumentEntryPWC", element);
	}

	public void test12FolderEntry() {
		UUID u = UUID.randomUUID();

		EntryType e = newAtomEntryType(u.toString(),
				EnumBaseObjectTypeIds.CMIS_FOLDER, "customer", true, true,
				null, "CMIS Example Folder as Customer type", null, null, false);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("FolderEntry", element);
	}

	public void test13PolicyEntry() {
		UUID u = UUID.randomUUID();

		EntryType e = newAtomEntryType(u.toString(),
				EnumBaseObjectTypeIds.CMIS_POLICY, "policy", true, true, null,
				"CMIS Example Policy", null, null, false);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("PolicyEntry", element);
	}

	public void test14RelationshipEntry() {
		UUID u = UUID.randomUUID();

		EntryType e = newAtomEntryType(u.toString(),
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP, "compounddocument",
				true, true, null,
				"CMIS Example Relationship as Compound Document type", null,
				null, false);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("RelationshipEntry", element);
	}

	public void test15FolderChildren() {
		FeedType f = newAtomFeedType(cmisFeedTypes.FOLDERCHILDREN,
				"folder1feed", "Feed for folder1", true, UUID.randomUUID()
						.toString());

		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_FOLDER, "customer", true,
						true, null, "CMIS Example Folder of type Customer",
						"customer1", null, false));

		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						true, null, "CMIS Example Doc as Invoice type",
						"08-01-2009 Invoice.pdf", null, false));

		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						true, null, "CMIS Example Doc as Invoice type",
						"08-01-2009 Large Invoice.pdf", null, false));

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger
						.valueOf(f.getEntry().size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("FolderChildren", element);
	}

	public void test15FolderDescendants() {
		UUID pUUID = UUID.randomUUID();

		FeedType f = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, pUUID
				.toString(), "Feed for folder1", false, UUID.randomUUID()
				.toString());

		// add a couple of folders
		EntryType e = null;

		// folder1
		String fUUID = UUID.randomUUID().toString();
		e = newAtomEntryType(fUUID, EnumBaseObjectTypeIds.CMIS_FOLDER,
				"customer", true, true, null,
				"CMIS Example Folder as Customer type", "customer", null, false);

		// folder1 has a couple of docs
		FeedType f1 = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, fUUID,
				"CMIS Example Folder as Customer type", false, pUUID.toString());

		f1.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						true, null, "CMIS Example Doc as Invoice type",
						"invoice1.pdf", null, false));
		f1.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						true, null, "CMIS Example Doc as Invoice type",
						"invoice2.pdf", null, false));
		// save
		JAXBElement<FeedType> kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);
		f.getEntry().add(e);

		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_FOLDER, "customer", true,
						true, null, "CMIS Example Folder as Customer type",
						"customer2", null, false));

		// add in a doc
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						true, null, "CMIS Example Doc as Invoice type",
						"invoice3.pdf", null, false));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("FolderDescendants", element);
	}

	public void test15TypeChildren() {
		FeedType f = newAtomFeedType(cmisFeedTypes.TYPECHILDREN, "type1feed",
				"Type Children", true, UUID.randomUUID().toString());
		EntryType e = null;

		e = newTypeDefinitionType("document-invoice",
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, false);
		f.getEntry().add(e);

		e = newTypeDefinitionType("folder-invoice",
				EnumBaseObjectTypeIds.CMIS_FOLDER, false);
		f.getEntry().add(e);

		e = newTypeDefinitionType("customer-relationship",
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP, false);
		f.getEntry().add(e);

		e = newTypeDefinitionType("security-policy",
				EnumBaseObjectTypeIds.CMIS_POLICY, false);
		f.getEntry().add(e);

		f.getAnyOther().add(raFactory.createNumItems(BigInteger.valueOf(4)));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("TypeChildren", element);
	}

	public void test20Acl() {
		CmisAccessControlListType acl = getACL();

		// write it
		JAXBElement<CmisAccessControlListType> element = coreFactory
				.createAcl(acl);
		writeOutput("ACL", element);
	}

	public void test20Query() {
		CmisQueryType q = getQueryType("SELECT * FROM cmis:document", 50, 0,
				true, true);

		// write it
		JAXBElement<CmisQueryType> element = coreFactory.createQuery(q);
		writeOutput("Query", element);
	}

	public void test20Service() {
		AppServiceType q = newServiceType();

		// write it
		JAXBElement<AppServiceType> element = appFactory.createService(q);
		writeOutput("Service", element);
	}

	public void test30ChangeLog() {
		FeedType f = newAtomFeedType(cmisFeedTypes.CHANGELOG, "folder1feed",
				"changelog feed", true, null);

		// add a couple of folders
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_FOLDER, "customer", true,
						true, EnumTypeOfChanges.CREATED,
						"CMIS Example Folder as Customer type", "customer1",
						null, false));
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_FOLDER, "customer", true,
						true, EnumTypeOfChanges.DELETED,
						"CMIS Example Folder as Customer type", "customer2",
						null, false));
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_FOLDER, "customerpolicy",
						true, true, EnumTypeOfChanges.UPDATED,
						"CMIS Example Folder as Customer Policy type",
						"policy", null, false));

		// add in a doc
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "policy", false,
						true, EnumTypeOfChanges.SECURITY,
						"CMIS Example Document as Policy type", "policy.pdf",
						null, false));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("ChangeLog", element);
	}

	public void test30DocumentEntryWithChanges() {
		EntryType e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "loan", false, true,
				EnumTypeOfChanges.CREATED, "CMIS Example Document - Loan",
				null, null, false);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("DocumentEntryWithChanges", element);
	}

	public void test40TypeDefinition() {
		JAXBElement<EntryType> element = null;
		EntryType e = null;

		e = newTypeDefinitionType("document-invoice",
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, false);
		element = atomFactory.createEntry(e);
		writeOutput("TypeDocumentWithout", element);

		e = newTypeDefinitionType("document-invoice",
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, true);
		element = atomFactory.createEntry(e);
		writeOutput("TypeDocumentWith", element);

		e = newTypeDefinitionType("folder-invoice",
				EnumBaseObjectTypeIds.CMIS_FOLDER, false);
		element = atomFactory.createEntry(e);
		writeOutput("TypeFolderWithout", element);

		e = newTypeDefinitionType("folder-invoice",
				EnumBaseObjectTypeIds.CMIS_FOLDER, true);
		element = atomFactory.createEntry(e);
		writeOutput("TypeFolderWith", element);

		e = newTypeDefinitionType("customer-relationship",
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP, false);
		element = atomFactory.createEntry(e);
		writeOutput("TypeRelationshipWithout", element);

		e = newTypeDefinitionType("customer-relationship",
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP, true);
		element = atomFactory.createEntry(e);
		writeOutput("TypeRelationshipWith", element);

		e = newTypeDefinitionType("security-policy",
				EnumBaseObjectTypeIds.CMIS_POLICY, false);
		element = atomFactory.createEntry(e);
		writeOutput("TypePolicyWithout", element);

		e = newTypeDefinitionType("security-policy",
				EnumBaseObjectTypeIds.CMIS_POLICY, true);
		element = atomFactory.createEntry(e);
		writeOutput("TypePolicyWith", element);
	}

	public void test50EX_ATOMHEIRARCHY() {
		UUID pUUID = UUID.randomUUID();

		// add a couple of folders
		EntryType e = null;

		// folder1
		String fUUID = UUID.randomUUID().toString();
		e = newAtomEntryType(fUUID, EnumBaseObjectTypeIds.CMIS_FOLDER,
				"customer", false, false, null,
				"CMIS Example Folder as Customer type", "customer",
				"cmis:objectId", true);

		// folder1 has a couple of docs
		FeedType f1 = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, fUUID,
				"CMIS Example Folder as Customer type", false, pUUID.toString());

		EntryType e2 = newAtomEntryType(fUUID,
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "customer", false, false,
				null, "CMIS Example Child of Folder", "document",
				"cmis:objectId", true);
		f1.getEntry().add(e2);

		// save
		JAXBElement<FeedType> kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("atompub/atomheirarchy", element);
	}

	public void test50EX_Attributes() {
		CmisObjectType cot = new CmisObjectType();
		CmisPropertiesType cpt = new CmisPropertiesType();

		String u = UUID.randomUUID().toString();
		Link l = getAtomLink(EnumLinkRelations.ALTERNATE.value(), URL_BASE
				+ "/rendition/" + u + "/1", MIMETYPE_HTML, null, null, null);
		l.getOtherAttributes().put(_renditionKind_QNAME,
				EnumRenditionKind.CMIS_THUMBNAIL.value());
		writeOutput("atompub/attribute_renditionKind", l);

		l = getAtomLink(EnumLinkRelations.DOWN.value(), URL_BASE + "/children/"
				+ u + "/1", MIMETYPE_ATOMFEED, null, u, null);
		writeOutput("atompub/attribute_id", l);
	}

	public void test50EX_CMISAtom() {
		EntryType e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false, false,
				null, "CMIS Example Document", null, null, true);

		EntryTypeHelper eh = new EntryTypeHelper(e);

		Content c = new Content();
		c.getContent().add("some text");
		c.getType().add("text");

		eh.setContent(c);

		eh.removeProperty(EnumPropertiesBase.CMIS_OBJECT_ID.value());

		// write it
		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		writeOutput("atompub/CMISAtomForPost", element);
	}

	public void test50EX_CMISTREE() {
		UUID pUUID = UUID.randomUUID();

		FeedType f = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, pUUID
				.toString(), "Feed for folder1", false, UUID.randomUUID()
				.toString());

		// add a couple of folders
		EntryType e = null;

		// folder1
		String fUUID = UUID.randomUUID().toString();
		e = newAtomEntryType(fUUID, EnumBaseObjectTypeIds.CMIS_FOLDER,
				"customer", false, false, null,
				"CMIS Example Folder as Customer type", "customer",
				"cmis:objectId", false);

		// folder1 has a couple of docs
		FeedType f1 = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, fUUID,
				"CMIS Example Folder as Customer type", false, pUUID.toString());

		f1.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						false, null, "CMIS Example Doc as Invoice type",
						"invoice1.pdf", "cmis:objectId", false));

		// save
		JAXBElement<FeedType> kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);
		f.getEntry().add(e);

		// add in a doc
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						false, null, "CMIS Example Doc as Invoice type",
						"invoice3.pdf", "cmis:objectId", false));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/cmistree", element);
	}

	public void test50EX_COL_CHILDRENPOST() {
		HashMap<String, String> headers = null;

		String d = UUID.randomUUID().toString();
		String r = UUID.randomUUID().toString();
		String n = UUID.randomUUID().toString();

		HashMap<String, String> h = new HashMap<String, String>();

		EntryType e = newAtomEntryType(d, EnumBaseObjectTypeIds.CMIS_DOCUMENT,
				"invoice", false, false, null, "Document - To Be Moved", null,
				"cmis:objectId cmis:objectTypeId", true);

		EntryTypeHelper eh = new EntryTypeHelper(e);

		Content c = new Content();
		c.setSrc(URL_BASE + "/content/" + d);
		eh.setContent(c);

		JAXBElement<EntryType> element = atomFactory.createEntry(eh
				.getEntryType());
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_childrenpost", "/obj/"
				+ d + "?sourceFolderId=" + n, null, MIMETYPE_ATOMENTRY, req);

		// do the response
		EntryType e1 = newAtomEntryType(r, EnumBaseObjectTypeIds.CMIS_DOCUMENT,
				"invoice", false, false, null, "Document - To Be Moved", null,
				null, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + r;
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_childrenpost", headers, httpStatus.S201,
				MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_COL_CHILDRENPOSTCREATE() {
		HashMap<String, String> headers = null;

		String d = UUID.randomUUID().toString();
		String r = UUID.randomUUID().toString();
		String n = UUID.randomUUID().toString();

		HashMap<String, String> h = new HashMap<String, String>();

		EntryType e = newAtomEntryType(d, EnumBaseObjectTypeIds.CMIS_DOCUMENT,
				"invoice", false, false, null, "New Invoice", null,
				"cmis:objectId cmis:objectTypeId", true);

		EntryTypeHelper eh = new EntryTypeHelper(e);

		Content c = new Content();
		c.getType().add("text");
		c.getContent().add("this is the content of the new document");
		eh.setContent(c);

		JAXBElement<EntryType> element = atomFactory.createEntry(eh
				.getEntryType());
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_childrenpostcreate",
				"/obj/" + d, null, MIMETYPE_ATOMENTRY, req);

		// do the response
		EntryType e1 = newAtomEntryType(r, EnumBaseObjectTypeIds.CMIS_DOCUMENT,
				"invoice", false, false, null, "New Invoice", null, null, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + r;
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_childrenpostcreate", headers,
				httpStatus.S201, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_COL_POLICYPOST() {
		HashMap<String, String> headers = null;
		String s = UUID.randomUUID().toString();
		String t = UUID.randomUUID().toString();
		EntryType e = newAtomEntryType(s, EnumBaseObjectTypeIds.CMIS_POLICY,
				"generalSecurityPolicy", false, false, null,
				"Security Policy for Invoices", null, "cmis:objectId", true);

		EntryTypeHelper eh = new EntryTypeHelper(e);

		JAXBElement<EntryType> element = atomFactory.createEntry(eh
				.getEntryType());
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_policypost", "/policies/"
				+ s, null, MIMETYPE_ATOMENTRY, req);

		// do the response
		String r = UUID.randomUUID().toString();
		EntryType e1 = newAtomEntryType(r, EnumBaseObjectTypeIds.CMIS_POLICY,
				"generalSecurityPolicy", false, false, null,
				"Security Policy for Invoices", null, null, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + r;
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_policypost", headers, httpStatus.S201,
				MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_COL_RELATIONSHIPSPOST() {
		HashMap<String, String> headers = null;
		String s = UUID.randomUUID().toString();
		String t = UUID.randomUUID().toString();
		EntryType e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP,
				"customerRelationships", false, false, null,
				"New Relationship", null, "cmis:objectTypeId", true);

		EntryTypeHelper eh = new EntryTypeHelper(e);

		eh.getObject().getProperties().getProperty().add(
				getPropertyId(
						EnumPropertiesRelationship.CMIS_SOURCE_ID.value(), s));

		eh.getObject().getProperties().getProperty().add(
				getPropertyId(
						EnumPropertiesRelationship.CMIS_TARGET_ID.value(), t));

		JAXBElement<EntryType> element = atomFactory.createEntry(eh
				.getEntryType());
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_relationshipspost",
				"/relationships/source/" + s, null, MIMETYPE_ATOMENTRY, req);

		// do the response
		String r = UUID.randomUUID().toString();
		EntryType e1 = newAtomEntryType(r,
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP,
				"customerRelationships", false, false, null,
				"New Relationship", null, null, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + r;
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_relationshipspost", headers,
				httpStatus.S201, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_FD_ALLVERSIONS() {
		UUID pUUID = UUID.randomUUID();

		FeedType f = newAtomFeedType(cmisFeedTypes.ALLVERSIONS, pUUID
				.toString(), "AllVersions for Document " + pUUID, false, null);

		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						false, null, "Invoice (Version1)", null,
						"cmis:objectId", false));

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger
						.valueOf(f.getEntry().size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/fd_allversions", element);
	}

	public void test50EX_FD_CHANGES() {
		String oId = UUID.randomUUID().toString();

		FeedType f = newAtomFeedType(cmisFeedTypes.CHANGELOG, "oId",
				"changelog feed", true, null);

		// add a couple of folders
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_FOLDER, "customerpolicy",
						true, false, EnumTypeOfChanges.UPDATED,
						"CMIS Example Folder as Customer Policy type",
						"policy", null, false));

		// add in a doc
		f.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "document", false,
						false, EnumTypeOfChanges.SECURITY,
						"CMIS Example Document", "invoice.pdf", null, false));

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger
						.valueOf(f.getEntry().size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/fd_changes", element);
	}

	public void test50EX_FD_FOLDERDESCENDANTS() {
		UUID pUUID = UUID.randomUUID();

		FeedType f = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, pUUID
				.toString(), "Feed for folder1", false, UUID.randomUUID()
				.toString());

		// add a couple of folders
		EntryType e = null;

		// folder1
		String fUUID = UUID.randomUUID().toString();
		e = newAtomEntryType(fUUID, EnumBaseObjectTypeIds.CMIS_FOLDER,
				"customer", false, false, null,
				"CMIS Example Folder as Customer type", "customer", null, false);

		// folder1 has a couple of docs
		FeedType f1 = newAtomFeedType(cmisFeedTypes.FOLDERDESCENDANTS, fUUID,
				"CMIS Example Folder as Customer type", false, pUUID.toString());

		f1.getEntry().add(
				newAtomEntryType(UUID.randomUUID().toString(),
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, "invoice", false,
						false, null, "CMIS Example Doc as Invoice type",
						"invoice1.pdf", null, false));

		// save the size
		f1.getAnyOther().add(
				raFactory.createNumItems(BigInteger.valueOf(f1.getEntry()
						.size())));
		// save
		JAXBElement<FeedType> kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);
		f.getEntry().add(e);

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger
						.valueOf(f.getEntry().size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/fd_folderdescendants", element);
	}

	public void test50EX_FD_FOLDERTREE() {
		UUID pUUID = UUID.randomUUID();

		FeedType f = newAtomFeedType(cmisFeedTypes.FOLDERTREE,
				pUUID.toString(), "FolderTree Feed of Folder1", false, UUID
						.randomUUID().toString());

		// add a couple of folders
		EntryType e = null;

		// folder1
		String fUUID = UUID.randomUUID().toString();
		e = newAtomEntryType(fUUID, EnumBaseObjectTypeIds.CMIS_FOLDER,
				"customer", false, false, null, "Customer Folder", "customer",
				null, false);

		f.getEntry().add(e);

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger
						.valueOf(f.getEntry().size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/fd_foldertree", element);
	}

	public void test50EX_FD_OBJECTPARENTS() {
		String oId = UUID.randomUUID().toString();

		FeedType f = newAtomFeedType(cmisFeedTypes.OBJECTPARENTS, oId,
				"Parent Feed for " + oId, true, null);

		EntryType e = null;
		e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_FOLDER, "customer", false, false,
				null, "Customer Folder", null, null, false);
		e.getAnyOther().add(raFactory.createRelativePathSegment("customer1"));
		f.getEntry().add(e);

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger
						.valueOf(f.getEntry().size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/fd_objectparents", element);
	}

	public void test50EX_FD_TYPEDESCENDANTS() {
		UUID pUUID = UUID.randomUUID();

		FeedType f = newAtomFeedType(cmisFeedTypes.TYPEDESCENDANTS, "",
				"Base Types", false, null);
		FeedType f1 = null;
		EntryType e = null;
		JAXBElement<FeedType> kids = null;

		e = newTypeDefinitionType("cmis:document",
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, false);

		f1 = newAtomFeedType(cmisFeedTypes.TYPEDESCENDANTS, "cmis:document",
				"Children for Document", false, "document");
		f1.getEntry().add(
				newTypeDefinitionType("invoice-document",
						EnumBaseObjectTypeIds.CMIS_DOCUMENT, false));
		f1.getAnyOther().add(
				raFactory.createNumItems(BigInteger.valueOf(f1.getEntry()
						.size())));
		kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);
		f.getEntry().add(e);

		e = newTypeDefinitionType("cmis:folder",
				EnumBaseObjectTypeIds.CMIS_FOLDER, false);
		f1 = newAtomFeedType(cmisFeedTypes.TYPEDESCENDANTS, "cmis:folder",
				"Children for Folder", false, "cmis:folder");
		f1.getEntry().add(
				newTypeDefinitionType("customer-folder",
						EnumBaseObjectTypeIds.CMIS_FOLDER, false));
		f1.getAnyOther().add(
				raFactory.createNumItems(BigInteger.valueOf(f1.getEntry()
						.size())));
		kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);
		f.getEntry().add(e);

		e = newTypeDefinitionType("cmis:relationship",
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP, false);
		f1 = newAtomFeedType(cmisFeedTypes.TYPEDESCENDANTS,
				"cmis:relationship", "Children for Relationship", false,
				"cmis:folder");
		f1.getEntry().add(
				newTypeDefinitionType("customer-relationship",
						EnumBaseObjectTypeIds.CMIS_RELATIONSHIP, false));
		f1.getAnyOther().add(
				raFactory.createNumItems(BigInteger.valueOf(f1.getEntry()
						.size())));
		kids = raFactory.createChildren(f1);
		e.getAnyOther().add(kids);
		f.getEntry().add(e);

		e = newTypeDefinitionType("cmis:policy",
				EnumBaseObjectTypeIds.CMIS_POLICY, false);
		f.getEntry().add(e);

		// save the size
		f.getAnyOther().add(
				raFactory.createNumItems(BigInteger.valueOf(f1.getEntry()
						.size())));

		// write it
		JAXBElement<FeedType> element = atomFactory.createFeed(f);
		writeOutput("atompub/fd_typedescendants", element);
	}

	public void test50EX_RSGET_ACL() {
		String d = UUID.randomUUID().toString();
		String url = "/objacl/" + d;
		String type = "acl";
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_" + type, url, null,
				MIMETYPE_CMISACL, null);

		// do the response
		CmisAccessControlListType acl = getACL();

		// save
		JAXBElement<CmisAccessControlListType> resultSet = coreFactory
				.createAcl(acl);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		headers.put("Location", url);

		writeHTTPResponse("atompub/rsget_" + type + "_resp", headers,
				httpStatus.S200, MIMETYPE_CMISACL, resp);
	}

	public void test50EX_RSGET_DOCUMENT() {
		String d = UUID.randomUUID().toString();
		String url = "/obj/" + d + "?filter=cmis:objectId";
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_document", url, null,
				MIMETYPE_ATOMENTRY, null);

		// do the response
		EntryType e = newAtomEntryType(d, EnumBaseObjectTypeIds.CMIS_DOCUMENT,
				"invoice", false, false, null, "Invoice", null,
				"cmis:objectId", false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		headers.put("Location", url);

		writeHTTPResponse("atompub/rsget_document_resp", headers,
				httpStatus.S200, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_RSGET_FOLDER() {
		String d = UUID.randomUUID().toString();
		String url = "/obj/" + d + "?filter=cmis:objectId";
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_folder", url, null,
				MIMETYPE_ATOMENTRY, null);

		// do the response
		EntryType e = newAtomEntryType(d, EnumBaseObjectTypeIds.CMIS_FOLDER,
				"cmis:folder", false, false, null, "Customer Folder", null,
				"cmis:objectId", false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		headers.put("Location", url);

		writeHTTPResponse("atompub/rsget_folder_resp", headers,
				httpStatus.S200, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_RSGET_POLICY() {
		String d = UUID.randomUUID().toString();
		String url = "/obj/" + d + "?filter=cmis:objectId";
		String type = "policy";
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_" + type, url, null,
				MIMETYPE_ATOMENTRY, null);

		// do the response
		EntryType e = newAtomEntryType(d, EnumBaseObjectTypeIds.CMIS_POLICY,
				"cmis:policy", false, false, null, "Security Policy", null,
				"cmis:objectId", false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		headers.put("Location", url);

		writeHTTPResponse("atompub/rsget_" + type + "_resp", headers,
				httpStatus.S200, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_RSGET_PWC() {
		String d = UUID.randomUUID().toString();
		String url = "/obj/" + d + "?filter=cmis:objectId";
		String type = "pwc";
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_" + type, url, null,
				MIMETYPE_ATOMENTRY, null);

		// do the response
		EntryType e = newAtomEntryType(d, EnumBaseObjectTypeIds.CMIS_DOCUMENT,
				"invoice", true, false, null, "Invoice", null, "cmis:objectId",
				false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		headers.put("Location", url);

		writeHTTPResponse("atompub/rsget_" + type + "_resp", headers,
				httpStatus.S200, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_RSGET_RELATIONSHIP() {
		String d = UUID.randomUUID().toString();
		String url = "/obj/" + d + "?filter=cmis:objectId";
		String type = "relationship";
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_" + type, url, null,
				MIMETYPE_ATOMENTRY, null);

		// do the response
		EntryType e = newAtomEntryType(d,
				EnumBaseObjectTypeIds.CMIS_RELATIONSHIP,
				"customerrelationship", false, false, null,
				"Customer Relationship", null, "cmis:objectId", false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		headers.put("Location", url);

		writeHTTPResponse("atompub/rsget_" + type + "_resp", headers,
				httpStatus.S200, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_RSGET_TYPE() {
		String d = UUID.randomUUID().toString();
		HashMap<String, String> headers = null;

		writeHTTPRequest(httpMethod.GET, "atompub/rsget_type", "/obj/" + d,
				null, MIMETYPE_ATOMENTRY, null);

		// do the response
		EntryType e = newTypeDefinitionType("cmis:document",
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + "cmis:document";
		headers.put("Location", u);

		writeHTTPResponse("atompub/rsget_type_resp", headers, httpStatus.S200,
				MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_SVC_CHECKEDOUTPOST() {
		HashMap<String, String> headers = null;
		EntryType e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "customer", false, false,
				null, "CMIS Example Document to checkout", null,
				"cmis:objectId", true);

		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_checkedoutpost",
				"/CheckedOut", null, MIMETYPE_ATOMENTRY, req);

		// do the response
		String uuid = UUID.randomUUID().toString();
		EntryType e1 = newAtomEntryType(uuid,
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "customer", true, false,
				null, "CMIS Example Child of Folder", null, null, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + uuid;
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_checkedoutpost", headers,
				httpStatus.S201, MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_SVC_QUERYPOST() {
		HashMap<String, String> headers = null;
		CmisQueryType q = getQueryType(
				"SELECT cmis:objectId FROM cmis:document", 50, 0, true, true);

		JAXBElement<CmisQueryType> element = coreFactory.createQuery(q);
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_querypost", "/Query",
				null, MIMETYPE_CMISQUERY, req);

		// do the response

		// result has 1 doc
		FeedType f1 = newAtomFeedType(cmisFeedTypes.QUERYRESULT, UUID
				.randomUUID().toString(), "CMIS Query Result for "
				+ q.getStatement(), false, UUID.randomUUID().toString());

		String uuid = UUID.randomUUID().toString();
		EntryType e = newAtomEntryType(uuid,
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "customer", true, false,
				null, "Resulting Document", null, "cmis:objectId", true);

		EntryTypeHelper eh = new EntryTypeHelper(e);

		// remove all properties
		eh.getObject().getProperties().getProperty().clear();

		// add back in object id
		eh.getObject().getProperties().getProperty().add(
				getPropertyId(EnumPropertiesBase.CMIS_OBJECT_ID.value(), uuid,
						"cmis:objectId"));

		List<Link> lLinks = eh.getLinks();
		List<Link> lRemove = new ArrayList<Link>();

		System.out.println("Starting to process links - " + lLinks.size());

		Iterator<Link> it = lLinks.iterator();
		while (it.hasNext()) {
			Link l = it.next();

			if (l.getRel().equals("up")) {
				System.out.println("Found up");
				lRemove.add(l);
			} else {
				System.out.println("This was not up");
			}

			if (l.getRel().equals("down"))
				lRemove.add(l);
		}

		it = lRemove.iterator();
		while (it.hasNext()) {
			Link l = it.next();
			lLinks.remove(l);
		}

		f1.getEntry().add(eh.getEntryType());

		// save
		JAXBElement<FeedType> resultSet = atomFactory.createFeed(f1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + "queryresult/" + UUID.randomUUID().toString();
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_querypost", headers, httpStatus.S201,
				MIMETYPE_ATOMFEED, resp);
	}

	public void test50EX_SVC_UNFILEDPOST() {
		HashMap<String, String> headers = null;
		EntryType e = newAtomEntryType(UUID.randomUUID().toString(),
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "customer", false, false,
				null, "CMIS Example Document to unfiled", null,
				"cmis:objectId", true);

		JAXBElement<EntryType> element = atomFactory.createEntry(e);
		String req = convertElementToString(element);

		writeHTTPRequest(httpMethod.POST, "atompub/rq_unfiledpost", "/Unfiled",
				null, MIMETYPE_ATOMENTRY, req);

		// do the response
		String uuid = UUID.randomUUID().toString();
		EntryType e1 = newAtomEntryType(uuid,
				EnumBaseObjectTypeIds.CMIS_DOCUMENT, "customer", false, false,
				null, "CMIS Example Document to unfiled", null, null, false);

		// save
		JAXBElement<EntryType> resultSet = atomFactory.createEntry(e1);
		String resp = convertElementToString(resultSet);

		headers = new HashMap<String, String>();
		String u = URL_BASE + "queryresult/" + uuid;
		headers.put("Location", u);
		headers.put("Content-Location", u);

		writeHTTPResponse("atompub/rp_unfiledpost", headers, httpStatus.S201,
				MIMETYPE_ATOMENTRY, resp);
	}

	public void test50EX_URITEMPLATE() {
		CmisUriTemplateType cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMENTRY);
		cut.setType(EnumUriTemplateType.OBJECTBYID.value());
		cut
				.setTemplate(URL_BASE
						+ "objectbyid/{id}?filter={filter}&includeAllowableActions={includeAllowableActions}&includePolicyIds={includePolicyIds}&includeRelationships={includeRelationships}&includeACL={includeACL}");
		JAXBElement<CmisUriTemplateType> elUri = raFactory
				.createUritemplate(cut);
		writeOutput("atompub/uritemplate", elUri);
		writeOutput("atompub/uriobjectbyid", elUri);

		cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMENTRY);
		cut.setType(EnumUriTemplateType.OBJECTBYPATH.value());
		cut
				.setTemplate(URL_BASE
						+ "objectbypath?p={path}&filter={filter}&includeAllowableActions={includeAllowableActions}&includePolicyIds={includePolicyIds}&includeRelationships={includeRelationships}&includeACL={includeACL}");
		elUri = raFactory.createUritemplate(cut);
		writeOutput("atompub/uriobjectbypath", elUri);

		cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMFEED);
		cut.setType(EnumUriTemplateType.QUERY.value());
		cut
				.setTemplate(URL_BASE
						+ "query?q={q}&searchAllVersions={searchAllVersions}&maxItems={maxItems}&skipCount={skipCount}&includeAllowableActions={includeAllowableActions}=&includeRelationships={includeRelationships}");
		elUri = raFactory.createUritemplate(cut);
		writeOutput("atompub/uriquery", elUri);

		cut = new CmisUriTemplateType();
		cut.setMediatype(MIMETYPE_ATOMENTRY);
		cut.setType(EnumUriTemplateType.QUERY.value());
		cut.setTemplate(URL_BASE + "type?id={id}");
		elUri = raFactory.createUritemplate(cut);
		writeOutput("atompub/uritypebyid", elUri);
	}

	public <T> void writeOutput(String file, Object o) {
		FileOutputStream out = null;
		boolean failed = ExampleTest.isTestFailed();

		// reset
		ExampleTest.setTestFailed(false);

		String fname = "examples/" + file + ".xml";

		try {
			out = new FileOutputStream(fname, false);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		}

		if (marshaller == null) {
			getMarshaller();
		}
		try {
			marshaller.marshal(o, out);
		} catch (JAXBException e) {
			e.printStackTrace();
			assertTrue(false);
		}

		try {
			CMISValidator cv = new CMISValidator("schema");
			cv.validate(fname);

			assertFalse(ExampleTest.isTestFailed());

		} catch (Exception e) {
			e.printStackTrace();
		}

		ExampleTest.setTestFailed(failed);
	}

	/*
	 * POST /edit/ HTTP/1.1 Host: example.org User-Agent: Thingio/1.0
	 * Authorization: Basic ZGFmZnk6c2VjZXJldA== Content-Type:
	 * application/atom+xml;type=entry Content-Length: nnn Slug: First Post
	 * 
	 * <?xml version="1.0"?> <entry xmlns="http://www.w3.org/2005/Atom">
	 * <title>Atom-Powered Robots Run Amok</title>
	 * <id>urn:uuid:1225c695-cfb8-4ebb-aaaa-80da344efa6a</id>
	 * <updated>2003-12-13T18:30:02Z</updated> <author><name>John
	 * Doe</name></author> <content>Some text.</content> </entry>
	 * 
	 * The server signals a successful creation with a status code of 201. The
	 * response includes a Location header indicating the Member Entry URI of
	 * the Atom Entry, and a representation of that Entry in the body of the
	 * response.
	 * 
	 * HTTP/1.1 201 Created Date: Fri, 7 Oct 2005 17:17:11 GMT Content-Length:
	 * nnn Content-Type: application/atom+xml;type=entry;charset="utf-8"
	 * Location: http://example.org/edit/first-post.atom ETag: "c180de84f991g8"
	 */

}
