package cmis.junit.examples;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.xml.bind.JAXBElement;
import javax.xml.namespace.QName;

import org.w3._2005.atom.AtomDateConstruct;
import org.w3._2005.atom.AtomPersonConstruct;
import org.w3._2005.atom.AtomTextConstruct;
import org.w3._2005.atom.Category;
import org.w3._2005.atom.FeedType;
import org.w3._2005.atom.Generator;
import org.w3._2005.atom.Icon;
import org.w3._2005.atom.Id;
import org.w3._2005.atom.Link;
import org.w3._2005.atom.Logo;
import org.w3._2007.app.AppCollectionType;

public class FeedTypeHelper {
	// QNAMEs
	private final static QName _Entry_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "entry");
	private final static QName _Email_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "email");
	private final static QName _Subtitle_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "subtitle");
	private final static QName _Uri_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "uri");
	private final static QName _Title_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "title");
	private final static QName _Author_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "author");
	private final static QName _Name_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "name");
	private final static QName _Contributor_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "contributor");
	private final static QName _Updated_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "updated");
	private final static QName _Feed_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "feed");
	private final static QName _Published_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "published");
	private final static QName _Summary_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "summary");
	private final static QName _Rights_QNAME = new QName(
			"http://www.w3.org/2005/Atom", "rights");

	// CMIS-RestAtom
	private final static QName _Type_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200901", "type");
	private final static QName _Children_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200901", "children");
	private final static QName _RepositoryInfo_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200901",
	"repositoryInfo");
	private final static QName _Object_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200901", "object");
	private final static QName _Uritemplate_QNAME = new QName(
			"http://docs.oasis-open.org/ns/cmis/restatom/200901", "uritemplate");

	// APP
	private final static QName _Collection_QNAME = new QName(
			"http://www.w3.org/2007/app", "collection");
	private final static QName _Edited_QNAME = new QName(
			"http://www.w3.org/2007/app", "edited");

	private final org.w3._2005.atom.ObjectFactory atomFactory = new org.w3._2005.atom.ObjectFactory();
	private final org.w3._2007.app.ObjectFactory appFactory = new org.w3._2007.app.ObjectFactory();
	private final org.oasis_open.docs.ns.cmis.restatom._200908.ObjectFactory raFactory = new org.oasis_open.docs.ns.cmis.restatom._200908.ObjectFactory();

	private List<AtomPersonConstruct> _authors;
	private List<Category> _categories;
	private List<AtomPersonConstruct> _contributor;
	private Generator _generator = null;
	private List<Link> _links;
	private List<AtomTextConstruct> _rights;
	private Icon _icon = null;
	private Logo _logo = null;

	private Id _id = null;
	private AtomTextConstruct _subtitle = null;
	private AtomTextConstruct _title = null;
	private AtomDateConstruct _updated = null;
	private AtomDateConstruct _edited = null;
	private AppCollectionType _collection = null;
	private List<Object> _anyOther = null;
	private List<Object> _anyLocal = null;

	@SuppressWarnings("unused")
	private FeedTypeHelper() {

	}

	public FeedTypeHelper(FeedType f) {
		if (f == null)
			throw new RuntimeException("EntryType is null");

		// get new lists
		_authors = new ArrayList<AtomPersonConstruct>();
		_categories = new ArrayList<Category>();
		_contributor = new ArrayList<AtomPersonConstruct>();
		_links = new ArrayList<Link>();
		_rights = new ArrayList<AtomTextConstruct>();
		_anyOther = new ArrayList<Object>();
		_anyLocal = f.getAnyLocal();

		Iterator<Object> it = f.getItems().iterator();
		while (it.hasNext()) {
			Object o = it.next();

			if (o instanceof Category) {
				Category c = (Category) o;
				_categories.add(c);
			} else if (o instanceof Id) {
				Id id = (Id) o;
				_id = id;
			} else if (o instanceof Link) {
				Link l = (Link) o;
				_links.add(l);
			} else if (o instanceof Generator) {
				_generator = (Generator) o;
			} else if (o instanceof Logo) {
				_logo = (Logo) o;
			} else if (o instanceof Icon) {
				_icon = (Icon) o;
			} else if (o instanceof JAXBElement<?>) {
				JAXBElement j = (JAXBElement) o;

				if (j.getName().equals(_Title_QNAME)) {
					_title = (AtomTextConstruct) j.getValue();
				} else if (j.getName().equals(_Subtitle_QNAME)) {
					_subtitle = (AtomTextConstruct) j.getValue();
				} else if (j.getName().equals(_Author_QNAME)) {
					_authors.add((AtomPersonConstruct) j.getValue());
				} else if (j.getName().equals(_Contributor_QNAME)) {
					_contributor.add((AtomPersonConstruct) j.getValue());
				} else if (j.getName().equals(_Updated_QNAME)) {
					_updated = (AtomDateConstruct) j.getValue();
				} else if (j.getName().equals(_Rights_QNAME)) {
					_rights.add((AtomTextConstruct) j.getValue());
				} else {
					// should not be here
					System.out.println("Not found JAXBElement of "
							+ j.getValue().getClass().getName());
				}
			}
		}

		// loop through anyOther
		it = f.getAnyOther().iterator();
		while (it.hasNext()) {
			Object o = it.next();

			if (o instanceof JAXBElement<?>) {
				JAXBElement j = (JAXBElement) o;

				if (j.getName().equals(_Edited_QNAME)) {
					_edited = (AtomDateConstruct) j.getValue();
				} else if (j.getName().equals(_Collection_QNAME)) {
					_collection = (AppCollectionType) j.getValue();
				} else {
					System.out.println("Not found JAXBElement of "
							+ j.getValue().getClass().getName());
					_anyOther.add(o);
				}
			} else {
				System.out
				.println("Not found object " + o.getClass().getName());
				_anyOther.add(o);
			}
		}
	}

	/**
	 * @return the anyLocal
	 */
	public List<Object> getAnyLocal() {
		return _anyLocal;
	}

	/**
	 * @return the anyOther
	 */
	public List<Object> getAnyOther() {
		return _anyOther;
	}

	/**
	 * @return the authors
	 */
	public List<AtomPersonConstruct> getAuthors() {
		return _authors;
	}

	/**
	 * @return the categories
	 */
	public List<Category> getCategories() {
		return _categories;
	}

	/**
	 * @return the collection
	 */
	public AppCollectionType getCollection() {
		return _collection;
	}

	/**
	 * @return the contributor
	 */
	public List<AtomPersonConstruct> getContributor() {
		return _contributor;
	}

	/**
	 * @return the edited
	 */
	public AtomDateConstruct getEdited() {
		return _edited;
	}

	public FeedType getFeedType() {
		FeedType f = new FeedType();

		Iterator it;

		it = _authors.iterator();
		while (it.hasNext()) {
			f.getItems().add(
					atomFactory.createAuthor((AtomPersonConstruct) it.next()));
		}

		f.getItems().addAll(_categories);

		it = _contributor.iterator();
		while (it.hasNext()) {
			f.getItems().add(
					atomFactory.createContributor((AtomPersonConstruct) it
							.next()));
		}

		f.getItems().addAll(_links);

		it = _rights.iterator();
		while (it.hasNext()) {
			f.getItems().add(
					atomFactory.createRights((AtomTextConstruct) it.next()));
		}

		if (_id != null)
			f.getItems().add(_id);

		if (_title != null)
			f.getItems().add(atomFactory.createTitle(_title));
		if (_updated != null)
			f.getItems().add(atomFactory.createUpdated(_updated));

		if (_generator != null)
			f.getItems().add(_generator);
		if (_icon != null)
			f.getItems().add(_icon);
		if (_logo != null)
			f.getItems().add(_logo);

		if (_subtitle != null)
			f.getItems().add(atomFactory.createSubtitle(_subtitle));

		if (_collection != null)
			f.getAnyOther().add(_collection);

		if (_edited != null)
			f.getAnyOther().add(appFactory.createEdited(_edited));

		f.getAnyOther().addAll(_anyOther);
		f.getAnyLocal().addAll(_anyLocal);

		return (f);
	}

	/**
	 * @return the generator
	 */
	public Generator getGenerator() {
		return _generator;
	}

	/**
	 * @return the icon
	 */
	public Icon getIcon() {
		return _icon;
	}

	/**
	 * @return the id
	 */
	public Id getId() {
		return _id;
	}

	/**
	 * @return the links
	 */
	public List<Link> getLinks() {
		return _links;
	}

	/**
	 * @return the logo
	 */
	public Logo getLogo() {
		return _logo;
	}

	/**
	 * @return the rights
	 */
	public List<AtomTextConstruct> getRights() {
		return _rights;
	}

	/**
	 * @return the subtitle
	 */
	public AtomTextConstruct getSubtitle() {
		return _subtitle;
	}

	/**
	 * @return the title
	 */
	public AtomTextConstruct getTitle() {
		return _title;
	}

	/**
	 * @return the updated
	 */
	public AtomDateConstruct getUpdated() {
		return _updated;
	}

	/**
	 * @param collection
	 *            the collection to set
	 */
	public void setCollection(AppCollectionType collection) {
		_collection = collection;
	}

	/**
	 * @param edited
	 *            the edited to set
	 */
	public void setEdited(AtomDateConstruct edited) {
		_edited = edited;
	}

	/**
	 * @param generator
	 *            the generator to set
	 */
	public void setGenerator(Generator generator) {
		_generator = generator;
	}

	/**
	 * @param icon
	 *            the icon to set
	 */
	public void setIcon(Icon icon) {
		_icon = icon;
	}

	/**
	 * @param id
	 *            the id to set
	 */
	public void setId(Id id) {
		_id = id;
	}

	/**
	 * @param logo
	 *            the logo to set
	 */
	public void setLogo(Logo logo) {
		_logo = logo;
	}

	/**
	 * @param subtitle
	 *            the subtitle to set
	 */
	public void setSubtitle(AtomTextConstruct subtitle) {
		_subtitle = subtitle;
	}

	/**
	 * @param title
	 *            the title to set
	 */
	public void setTitle(AtomTextConstruct title) {
		_title = title;
	}

	/**
	 * @param updated
	 *            the updated to set
	 */
	public void setUpdated(AtomDateConstruct updated) {
		_updated = updated;
	}

}
