package cmis.junit.examples;

import java.util.HashMap;

import org.oasis_open.docs.ns.cmis.core._200908.CmisPropertiesType;
import org.oasis_open.docs.ns.cmis.core._200908.CmisProperty;

public class PropertyFilter {
	private String _filter = null;
	private HashMap<String, Boolean> mFilter = null;
	boolean wildcard = false;

	PropertyFilter(String filter) {
		mFilter = new HashMap<String, Boolean>();
		_filter = filter;

		if (filter != null) {
			if (filter.equals("*")) {
				wildcard = true;
			} else {
				String[] temp = null;
				temp = filter.split(" ");

				for (int i = 0; i < temp.length; i++) {
					mFilter.put(temp[i], Boolean.TRUE);
				}
			}
		} else {
			wildcard = true;
		}
	}

	public void addProperty(CmisPropertiesType cpt, CmisProperty cp) {
		if (include(cp.getPropertyDefinitionId()))
			cpt.getProperty().add(cp);
	}

	public boolean include(String pName) {
		if (wildcard == true || mFilter.containsKey(pName))
			return true;
		return false;
	}
}
